ColWhite = Color.new(255,255,255)
ColBlack = Color.new(0,0,0)
ColRed   = Color.new(255,0,0)

function WaitForCross( Delay )
   
   if Delay then
      ExitAt = os.clock() + Delay
   end
   
   while true do
      pad = Controls.read()
      if not(pad:cross()) then break end
      screen.waitVblankStart()
   end
   
   while true do
      pad = Controls.read()
      if pad:cross() then break end
      if Delay then
         if ExitAt <= os.clock() then break end
      end
      
      if ShowScore < Score then
         ShowScore = math.ceil( ShowScore + (Score - ShowScore)/10 )
         DrawScreen()
      end
      
      screen.waitVblankStart()
   end
   
   ExitAt = nil
end

function WaitForCross2( Delay )
   if Delay then
      ExitAt = os.clock() + Delay
   end
   
   while true do
      pad = Controls.read()
      if not(pad:cross()) then break end
      screen.waitVblankStart()
   end
   
   while true do
      pad = Controls.read()
      if pad:cross() then break end
      if Delay then
         if ExitAt <= os.clock() then break end
      end
      
      screen.waitVblankStart()
   end
   
   ExitAt = nil
end

function ReadTile(UnitX,UnitY)
   if (UnitX >= 0) and (UnitX <40) and (UnitY >= 0) and (UnitY <22) then
      return string.byte(GameField[UnitY+1], UnitX+1)
   else
      return -1
   end
end

function IsPlatform(UnitX,UnitY)      
   if (UnitX >= 0) and (UnitX <40) and (UnitY >= 0) and (UnitY <22) then
      if BlockPlatform[string.byte(GameField[UnitY+1], UnitX+1)] then
         return true
      else
         return false
      end
   else
      return -1
   end
end

function IsCollide(UnitX,UnitY)      
   if (UnitX >= 0) and (UnitX <40) and (UnitY >= 0) and (UnitY <22) then
      if BlockCollide[string.byte(GameField[UnitY+1], UnitX+1)] then
         return true
      else
         return false
      end
   else
      return -1
   end
end

function IsHit(UnitX,UnitY)
   if (UnitX >= 0) and (UnitX <40) and (UnitY >= 0) and (UnitY <22) then
      if BlockHit[string.byte(GameField[UnitY+1], UnitX+1)] then
         return true
      else
         return false
      end
   else
      return -1
   end
end

function IsSlip(UnitX,UnitY)
   if (UnitX >= 0) and (UnitX <40) and (UnitY >= 0) and (UnitY <22) then
      if BlockSlip[string.byte(GameField[UnitY+1], UnitX+1)] then
         return true
      else
         return false
      end
   else
      return -1
   end
end

function WriteTile(UnitX,UnitY,NewUnit)
   GameField[UnitY+1] = string.sub(GameField[UnitY+1],1,UnitX) .. string.char(NewUnit) .. string.sub(GameField[UnitY+1],UnitX+2,string.len(GameField[UnitY+1]))
end

function DrawScreen()
   screen:blit(0, 0, ImgLevel, false)
   
   DrawDoor()
   DrawBltFire()
   
   DrawPlatforms()
   
   DrawChest()
   DrawEggSpowing()
   DrawFruit()   
   DrawCoins()
   DrawKey()
   
   DrawStarburst()
   
   for i=0,MaxBullets -1 do
      DrawBullet(i)
   end
   
   for i=0,Enemies -1 do
      DrawEnemy(i)
   end
   
   DrawThrownEgg()
   
   DrawPlayer()
   
   DrawParticles()
   
   DrawAddedPoints()
   
   if Lives > 0 then
      for i=1,Lives do
         screen:blit(i *24, 245, ImgBobChipke,0,0,24,24, true)
      end
   end
   
   if PGotKey then
      screen:blit(228, 245, ImgBobGoodies,6 *24,0,24,24, true)
   end
   
   FontDraw(1,screen ,450 -FontTextsize(1,Score) ,250,Score)
   
   if MessageCountdown > 0 then
      MessageCountdown = MessageCountdown -1
      FontDraw(1,screen ,(480 -FontTextsize(1,Message)) /2,110,Message)
      
      if System.powerIsLowBattery() and BatteryAlert then
         screen:blit(210,116, ImgBattery, true)
         MessageSub = "BATTERY LOW !!!"
         FontDraw(2,screen ,(480 -FontTextsize(2,MessageSub)) /2,165,MessageSub)
      elseif MessageSub ~= "" then
         FontDraw(2,screen ,(480 -FontTextsize(2,MessageSub)) /2,130,MessageSub)
      end
      
   end
   
   if DWindowVisible then
      local TileYpos = math.floor(PlayerYpos/12)
      local TileXpos = math.floor((PlayerXpos) /12)
      
      if (TileYpos < 22) and (TileYpos >= 0) and (TileXpos < 40) and (TileXpos >= 0) then
         local CurTile = ReadTile(TileXpos,TileYpos)
         local SPEgg = "/"
         local SHit = "/"
         if PEgg then SPEgg = "Yes" elseif PEgg == false then SPEgg = "No" end
         if IsHit(TileXpos,TileYpos) then SHit = "Yes" else SHit = "No" end
         screen:print( 100,262,"x:" .. TileXpos .. " y:" .. TileYpos .. " tile:" .. CurTile )
         screen:print( 100,252,"Egg: " .. SPEgg .. "    BgHit:" .. SHit)
         
      end
      
   end
   
   DWindowDraw()
   
   if GameRunning ~= true then
      screen:blit((480-224)/2, 110, ImgGameOver, 0, 0, 224, 33, true)
   end
   
   screen:flip()
end

function DoWirlAnim()
   
   local Rd = math.atan(1) /45
   
   local BobsImg = ImgBobChipke
   local BobsSize = 24
   local BobYShift = 0
   
   local PbobX = 12
   local PbobY = 1
   
   local PlayerTrueX = PlayerXpos -(BobsSize/2)
   local PlayerTrueY = PlayerYpos +12 -BobsSize +BobYShift
   
   local DoorTrueX = DoorX *12 -6
   local DoorTrueY = DoorY *12 -12
   
   local WirlX = 240
   local WirlY = 136
   
   local PAng = 0
   local tmpVal = (PlayerTrueY-WirlY)
   
   local PDist = 0
   
   if tmpVal ~= 0 then PAng = math.atan( (PlayerTrueX-WirlX) /tmpVal ) end
   
   if math.sin(PAng) ~= 0 then
      PDist = (PlayerTrueX-WirlX) / math.sin(PAng)
   else
      PDist = (PlayerTrueY-WirlY) / math.cos(PAng)
   end
   
   local WMoveAnim = 0
   
   while WMoveAnim < 200 do
      screen:blit(0, 0, ImgLevel, false)
      
      DrawDoor()
      DrawChest()
      
      PlayerTrueX = WirlX + ((DoorTrueX-WirlX) /200 * WMoveAnim) + math.sin(PAng) * (PDist /200 * (200-WMoveAnim))
      PlayerTrueY = WirlY + ((DoorTrueY-WirlY) /200 * WMoveAnim) + math.cos(PAng) * (PDist /200 * (200-WMoveAnim))
      
      screen:blit(PlayerTrueX, PlayerTrueY, BobsImg,(PbobX + math.mod( math.floor( WMoveAnim/6 ) ,2 ) )*BobsSize ,PbobY*BobsSize ,BobsSize ,BobsSize , true)
      
      DrawAddedPoints()
         
      if Lives > 0 then
         for i=1,Lives do
            screen:blit(i *24, 245, ImgBobChipke,0,0,24,24, true)
         end
      end
      
      FontDraw(1,screen ,450 -FontTextsize(1,Score) ,250,Score)
      
      DWindowDraw()
      
      PAng = PAng + (Rd * WMoveAnim/5 )
      
      if PAng > (Rd*360) then PAng = PAng - (Rd*360) end
      
      WMoveAnim = WMoveAnim +2
      
      screen:flip()
      screen.waitVblankStart(3)
   end
end

function DrawPlatforms()
   if PlatformsUsed > 0 then
      for i =0, PlatformsUsed -1 do
         if PlatformDir[i] == 1 then
            PlatformElevation[i] = PlatformElevation[i] -1.5
            if PlatformElevation[i] <= 0 then
               PlatformDir[i] = 0
               PlatformElevation[i] = 0
            end
         else
            PlatformElevation[i] = PlatformElevation[i] +1.5
            if PlatformElevation[i] >= 12 *4 then
               PlatformDir[i] = 1
               PlatformElevation[i] = 12 *4
            end
         end
         
         screen:blit( PlatformX[i] *12, PlatformY[i] *12 -PlatformElevation[i], ImgTiles , 13 *12 , 14 *12 , 36, 12, true )
      end
   end
end

function NewFruit(PosX,PosY,VelX,VelY,FruitType)
   local ID = 0   
   while Fruit[ID] ~= nill do ID = ID +1 end
   
   Fruit[ID] = {}
   Fruit[ID].PosX = PosX
   Fruit[ID].PosY = PosY
   Fruit[ID].VelX = VelX
   Fruit[ID].VelY = VelY
   Fruit[ID].Moving = true
   Fruit[ID].Counter = 0
   Fruit[ID].Type = FruitType
end

function DrawFruit()
   
   local NewPosX = 0
   local NewPosY = 0
   
   local NewTileX = 0
   local NewTileY = 0
   local NewTile = 0
   local NewTileCollide = 0
   
   local OldTileX = 0
   local OldTileY = 0
   local OldTile = 0
   local OldTilePlatform = 0
   
   for ID in pairs(Fruit) do   
      if Fruit[ID].Counter < 70 then
         
         if (Fruit[ID].PosY  < 272) and Fruit[ID].Moving then
            OldTileX = math.floor(Fruit[ID].PosX /12)
            OldTileY = math.floor((Fruit[ID].PosY +11) /12)
            
            NewPosX = Fruit[ID].PosX + Fruit[ID].VelX
            NewPosY = Fruit[ID].PosY + Fruit[ID].VelY
            
            NewTileX = math.floor(NewPosX /12)
            NewTileY = math.floor((NewPosY +11) /12)
            
            OldTile = ReadTile(OldTileX,OldTileY)
            NewTile = ReadTile(NewTileX,NewTileY)
            
            OldTilePlatform = IsPlatform(NewTileX,OldTileY)
            NewTilePlatform = IsPlatform(NewTileX,NewTileY)
            
            if (OldTileX ~= NewTileX) or (OldTileY ~= NewTileY) then
               
               if (NewTileX >= 0) and (NewTileX < 40) then
                  
                  if (NewTilePlatform == true) and (OldTilePlatform == false) and (Fruit[ID].VelY > 0) then
                     Fruit[ID].PosY = NewTileY *12 -11
                     
                     Fruit[ID].Moving = false
                     print ("Fruit landed")
                  else
                     Fruit[ID].PosX = NewPosX
                     Fruit[ID].PosY = NewPosY
                  end
                  
               else
                  Fruit[ID].VelX = -Fruit[ID].VelX
               end
               
            else
               Fruit[ID].PosX = NewPosX
               Fruit[ID].PosY = NewPosY
            end
            
            Fruit[ID].VelY = Fruit[ID].VelY +.7
            if Fruit[ID].VelY > 10 then Fruit[ID].VelY = 10 end
         end
         
         if (PlayerXpos > Fruit[ID].PosX -14) and (PlayerXpos < Fruit[ID].PosX +14) and (PlayerYpos > Fruit[ID].PosY -14) and (PlayerYpos < Fruit[ID].PosY +14) then
            NewAddedPoints(Fruit[ID].PosX,Fruit[ID].PosY,100)
            SndFruit:play()
            Fruit[ID] = nill
         else
            screen:blit(Fruit[ID].PosX -12, Fruit[ID].PosY -12, ImgBobGoodies, Fruit[ID].Type * 24, 48, 24, 24, true)
            Fruit[ID].Counter = Fruit[ID].Counter +1         
         end
      else
         Fruit[ID] = nill
      end      
   end
end

function DrawKey()
   
   if KeyCountdown > 0 then
      KeyCountdown = KeyCountdown -1
       if (KeyCountdown < 250) then
         if (PlayerXpos > KeyX *12 -14) and (PlayerXpos < KeyX *12 +14) and (PlayerYpos > KeyY *12 -14) and (PlayerYpos < KeyY *12 +14) then
            PGotKey = true
            KeyCountdown = 0
            SndFruit:play()
         else
            screen:blit(KeyX *12 -12, KeyY *12 -12, ImgBobGoodies,6 *24,0,24,24, true)
         end
      end
   end
   
   if (KeyCountdown < 250+9) and (KeyCountdown > 250-10) then
      local TWAnim = 250 +9 - KeyCountdown
      local BobSize = 24
      
      if TWAnim < 3 then
         screen:blit(KeyX*12 -(BobSize/2), KeyY*12 +12 -BobSize +1, ImgBobEgg, (TWAnim-1) *BobSize, 1 *BobSize, BobSize, BobSize, true)
      elseif TWAnim < 18 then
         local bobY = 1
         local bobX = math.mod(TWAnim -3,5) + 2
         screen:blit(KeyX*12 -(BobSize/2), KeyY*12 +12 -BobSize +1, ImgBobEgg, bobX *BobSize, bobY *BobSize, BobSize, BobSize, true)
         if bobX > 2 and TWAnim < 15 then
            screen:blit(KeyX*12 -(BobSize/2), KeyY*12 +12 -BobSize +1, ImgBobEgg, (bobX-3) *BobSize, bobY *BobSize, BobSize, BobSize, true)
         end
      end
   end
   
end

function DrawChest()
   if DropChest > 0 then
      if DropChest == 1 then
         Chest.PosY = Chest.PosY + Chest.VelY
         Chest.VelY = Chest.VelY + .7
         if Chest.PosY >= Chest.DestY then
            Chest.PosY = Chest.DestY
            DropChest = 2
         end
         screen:blit(Chest.PosX -24,Chest.PosY -36, ImgBobGoodies, 0, 0, 48, 48, true)
      elseif DropChest < 6 then
         screen:blit(Chest.PosX -24,Chest.PosY -36, ImgBobGoodies, 0, 0, 48, 48, true)
         DropChest = DropChest +1
      elseif DropChest < 8 then
         screen:blit(Chest.PosX -24,Chest.PosY -36, ImgBobGoodies, 48, 0, 48, 24, true)
         screen:blit(Chest.PosX -24,Chest.PosY -12, ImgBobGoodies, 0, 24, 48, 24, true)
         DropChest = DropChest +1
      elseif DropChest < 10 then
         screen:blit(Chest.PosX -24,Chest.PosY -36, ImgBobGoodies, 48*2, 0, 48, 24, true)
         screen:blit(Chest.PosX -24,Chest.PosY -12, ImgBobGoodies, 0, 24, 48, 24, true)
         DropChest = DropChest +1
      elseif DropChest < 55 then
         screen:blit(Chest.PosX -24,Chest.PosY -36, ImgBobGoodies, 48*2, 0, 48, 24, true)
         screen:blit(Chest.PosX -24,Chest.PosY -12, ImgBobGoodies, 0, 24, 48, 24, true)               
         if math.mod(DropChest,5) == 0 then
            -- NewCoin(Chest.PosX,Chest.PosY -20,(math.random(0,30)-15)/5,-9)            
            NewCoin(Chest.PosX,Chest.PosY -20,(math.floor((DropChest-10)/5)-4)/2,-9)
            SndNewCoin:play()
         end
         DropChest = DropChest +1
      else
         screen:blit(Chest.PosX -24,Chest.PosY -36, ImgBobGoodies, 48*2, 0, 48, 24, true)
         screen:blit(Chest.PosX -24,Chest.PosY -12, ImgBobGoodies, 0, 24, 48, 24, true)
      end
   end
end

function NewCoin(PosX,PosY,VelX,VelY)
   local ID = 0   
   while Coins[ID] ~= nill do ID = ID +1 end
   
   Coins[ID] = {}
   Coins[ID].PosX = PosX
   Coins[ID].PosY = PosY
   Coins[ID].VelX = VelX
   Coins[ID].VelY = VelY
   Coins[ID].Moving = true
   Coins[ID].Counter = 0
   
end

function DrawCoins()
   
   local NewPosX = 0
   local NewPosY = 0
   
   local NewTileX = 0
   local NewTileY = 0
   local NewTile = 0
   local NewTileCollide = 0
   
   local OldTileX = 0
   local OldTileY = 0   
   local OldTile = 0
   local OldTileCollide = 0
   
   for ID in pairs(Coins) do
      if Coins[ID].Counter < 150 then
         
         if (Coins[ID].PosY  < 272) and Coins[ID].Moving then
            OldTileX = math.floor(Coins[ID].PosX /12)
            OldTileY = math.floor((Coins[ID].PosY +11) /12)
            
            NewPosX = Coins[ID].PosX + Coins[ID].VelX
            NewPosY = Coins[ID].PosY + Coins[ID].VelY
            
            NewTileX = math.floor(NewPosX /12)
            NewTileY = math.floor((NewPosY +11) /12)
            
            OldTile = ReadTile(OldTileX,OldTileY)
            NewTile = ReadTile(NewTileX,NewTileY)
            
            OldTilePlatform = IsPlatform(NewTileX,OldTileY)
            NewTilePlatform = IsPlatform(NewTileX,NewTileY)
            
            if (OldTileX ~= NewTileX) or (OldTileY ~= NewTileY) then
               
               if (NewTileX >= 0) and (NewTileX < 40) then
                  
                  if (NewTilePlatform == true) and (OldTilePlatform == false) and (Coins[ID].VelY > 0) then
                     Coins[ID].VelY = -(Coins[ID].VelY *.66)
                  else
                     Coins[ID].PosX = NewPosX
                     Coins[ID].PosY = NewPosY
                  end
                  
               else
                  Coins[ID].VelX = -Coins[ID].VelX
               end
               
            else
               Coins[ID].PosX = NewPosX
               Coins[ID].PosY = NewPosY
            end
            
            Coins[ID].VelY = Coins[ID].VelY +.7
            if Coins[ID].VelY > 10 then Coins[ID].VelY = 10 end            
         end
         
         if (PlayerXpos > Coins[ID].PosX -14) and (PlayerXpos < Coins[ID].PosX +14) and (PlayerYpos > Coins[ID].PosY -14) and (PlayerYpos < Coins[ID].PosY +14) then
            NewAddedPoints(Coins[ID].PosX,Coins[ID].PosY,150)
            SndCoin:play()
            Coins[ID] = nill
         else
            screen:blit(Coins[ID].PosX -12, Coins[ID].PosY -9, ImgBobGoodies, (math.mod(math.floor(Coins[ID].Counter/3),4) +3) * 24, 72, 24, 24, true)
            Coins[ID].Counter = Coins[ID].Counter +1         
         end         
      else
         Coins[ID] = nill
      end
   end
end

function PrepairGoldenEggs()
   if EggSpownersUsed > 0 then
      for i =0, EggSpownersUsed -1 do
         if (EggSpownerState[i] > 0) and (EggSpownerState[i] < EggHatchtime -20) then
            EggSpownerState[i] = 1
         end
      end
   end
end

function DrawEggSpowing()
   if EnemiesLiving == 0 then
      if EggSpownersUsed > 0 then
         for i =0, EggSpownersUsed -1 do
            if (EggSpownerState[i] > 0) and (EggSpownerState[i] < 120) then
               if (PlayerYpos > EggSpownerY[i]*12 -15) and (PlayerYpos <= EggSpownerY[i]*12) and (PlayerXpos > EggSpownerX[i]*12 -5) and (PlayerXpos < EggSpownerX[i]*12 +5) then
                  EggSpownerState[i] = 0
                  NewAddedPoints(EggSpownerX[i]*12,EggSpownerY[i]*12,500)
                  SndFruit:play()
               else
                  EggSpownerState[i] = EggSpownerState[i] +1
                  local BobSize = 24
                  local EbobX = 7
                  local EbobY = 1
                  screen:blit(EggSpownerX[i]*12 -(BobSize/2), EggSpownerY[i]*12 +12 -BobSize +1, ImgBobEgg, EbobX *BobSize, EbobY *BobSize, BobSize, BobSize, true)
               end
            end
         end
      end
   else
      if EggSpownerActive > 0 then
         EggSpownerActive = EggSpownerActive -1
      elseif (EggSpownerActive == 0) and (EggSpownerState[EggSpownerNext] == 0) then
         print ("egg spown on: " .. EggSpownerNext)
         EggSpownerState[EggSpownerNext] = 1
         EggShellExploX[EggSpownerNext] = 0
         EggShellExploY[EggSpownerNext] = 1
         EggShellFall[EggSpownerNext] = 1
         
         EggSpownerNext = EggSpownerNext +1
         if EggSpownerNext == EggSpownersUsed then EggSpownerNext = 0 end
         EggSpownerActive = 200+math.floor(math.random()*550)
      end
      
      if EggSpownersUsed > 0 then
         
         for i =0, EggSpownersUsed -1 do
            if (EggSpownerState[i] > 10 ) and (EggSpownerState[i] < EggHatchtime -20) and (PEgg == false) then
               if (PlayerYpos > EggSpownerY[i]*12 -15) and (PlayerYpos <= EggSpownerY[i]*12) then
                  if (PlayerXpos > EggSpownerX[i]*12 -5) and (PlayerXpos < EggSpownerX[i]*12 +5) then
                     PEgg = true
                     EggSpownerState[i] = 0
                     EggSpownerActive = 50
                  end
               end
            end
            
            if EggSpownerState[i] ~= 0 then
               local BobSize = 24
               local EbobX = 0
               local EbobY = 0
               
               if EggSpownerState[i] > 8 then
                  if EggSpownerState[i] < EggHatchtime *.66 then
                     EbobX = 0
                     EbobY = 0
                     screen:blit(EggSpownerX[i]*12 -(BobSize/2), EggSpownerY[i]*12 +12 -BobSize +1, ImgBobEgg, EbobX *BobSize, EbobY *BobSize, BobSize, BobSize, true)
                  elseif EggSpownerState[i] < EggHatchtime -20 then
                     EbobX = 1
                     EbobY = 0
                     screen:blit(EggSpownerX[i]*12 -(BobSize/2), EggSpownerY[i]*12 +12 -BobSize +1, ImgBobEgg, EbobX *BobSize, EbobY *BobSize, BobSize, BobSize, true)
                  else
                     EbobX = 7
                     EbobY = 0
                     if EnemiesLiving < 12 then
                        screen:blit(EggSpownerX[i]*12 -(BobSize/2), EggSpownerY[i]*12 +12 -BobSize +1, ImgBobEgg, EbobX *BobSize, EbobY *BobSize, BobSize, BobSize, true)
                     end
                     screen:blit(EggSpownerX[i]*12 -(BobSize/2) +EggShellExploX[i], EggSpownerY[i]*12 +12 -BobSize +EggShellExploY[i], ImgBobEgg, 4 *BobSize, EbobY *BobSize, BobSize, BobSize, true)
                     screen:blit(EggSpownerX[i]*12 -(BobSize/2) -EggShellExploX[i], EggSpownerY[i]*12 +12 -BobSize +EggShellExploY[i], ImgBobEgg, 3 *BobSize, EbobY *BobSize, BobSize, BobSize, true)
                     
                     EggShellExploX[i] = EggShellExploX[i] +4
                     EggShellExploY[i] = EggShellExploY[i] + EggShellFall[i]
                     EggShellFall[i] = EggShellFall[i] *1.2
                  end
               end
               
               
               if EggSpownerState[i] < 3 then
                  -- screen:blit(EggSpownerX[i]*12 -(BobSize/2), EggSpownerY[i]*12 +12 -BobSize +1, ImgBobEgg, (i-1) *BobSize, 1 *BobSize, BobSize, BobSize, true)
                  screen:blit(EggSpownerX[i]*12 -(BobSize/2), EggSpownerY[i]*12 +12 -BobSize +1, ImgBobEgg, (EggSpownerState[i]-1) *BobSize, 1 *BobSize, BobSize, BobSize, true)
               elseif EggSpownerState[i] < 18 then            
                  EbobY = 1
                  EbobX = math.mod(EggSpownerState[i] -3,5) + 2
                  screen:blit(EggSpownerX[i]*12 -(BobSize/2), EggSpownerY[i]*12 +12 -BobSize +1, ImgBobEgg, EbobX *BobSize, EbobY *BobSize, BobSize, BobSize, true)               
                  if EbobX > 2 and EggSpownerState[i] < 15 then
                     screen:blit(EggSpownerX[i]*12 -(BobSize/2), EggSpownerY[i]*12 +12 -BobSize +1, ImgBobEgg, (EbobX-3) *BobSize, EbobY *BobSize, BobSize, BobSize, true)
                  end
               end
               
               EggSpownerState[i] = EggSpownerState[i] +1
               
               if EggSpownerState[i] == EggHatchtime then
                  EggSpownerState[i] = 0
                  
                  if EnemiesLiving < 12 then                  
                     local EnemyID = GetFreeEnemy()
                     
                     EnemyXpos[EnemyID] = EggSpownerX[i]*12
                     EnemyYpos[EnemyID] = EggSpownerY[i]*12
                     EnemyType[EnemyID] = 3
                     EnemyAction[EnemyID] = 0
                     EnemyAnimFrame[EnemyID] = 0
                     EnemyDir[EnemyID] = 0
                     EnemyLife[EnemyID] = true
                     EnemyDead[EnemyID] = false
                     
                     EnemiesLiving = EnemiesLiving +1
                  end
               end
            end
         end
      end
   end
end

function NewAddedPoints(PosX,PosY,Points)
   local ID = 0
   local PointsBackup = Points
   local PointsSize = 0
   
   while APoints[ID] ~= nill do ID = ID +1 end
   
   while (PointsBackup >= 1) do
      PointsSize = PointsSize +1
      PointsBackup = PointsBackup / 10
   end
   
   APoints[ID] = {}
   APoints[ID].Counter = 0
   APoints[ID].Size = PointsSize * 6 +1
   APoints[ID].PosX = PosX - (APoints[ID].Size / 2)
   APoints[ID].PosY = PosY   
   APoints[ID].Image = Image.createEmpty(APoints[ID].Size,7)
   FontDraw(2,APoints[ID].Image,0,0,Points)
   Score = Score + Points
   
end

function DrawAddedPoints()
   for ID in pairs(APoints) do
      if APoints[ID].Counter < 20 then
         APoints[ID].Counter = APoints[ID].Counter +1
         APoints[ID].PosY = APoints[ID].PosY -.5
         screen:blit(APoints[ID].PosX, APoints[ID].PosY, APoints[ID].Image, 0, 0, APoints[ID].Size, 7, true)
      else
         APoints[ID] = nill
      end
   end
end

function GetFreeEnemy()
   local EnemyFound = -1
   
   for i=0,Enemies -1 do
      if EnemyDead[i] then EnemyFound = i end
   end
   
   if EnemyFound == -1 then -- No dead enemies: Create new enemy
      EnemyFound = Enemies
      Enemies = Enemies +1
   end
   
   return EnemyFound
end

function DrawDoor()
   if DoorOpen and (DoorState < 4) then 
      DoorState = DoorState +1
      if DoorState == 4 then
         for i = 1,12 do
            NewStarburst(DoorX *12 , DoorY *12)
         end
      end
   end
   screen:blit(DoorX *12 -12, DoorY *12 -24, ImgDoor,DoorState *36 ,0 ,36 ,36 , true)
end

function UnlockDoor()
   DoorOpen = true
   PrepairGoldenEggs()
   print ("Door Open")
   if PGotKey then
      DropChest = 1
      NewParticle(ImgBobGoodies, 6 *24, 0, 24, 228 +12, 245 +12, 0, -7)
      
      PGotKey = false
      
      ExitLevelCountdown = 300
   else
      ExitLevelCountdown = 150
   end
end

function NewStarburst(Xpos,Ypos)
   local StarNr = -1
   
   for i = 1,20 do
      if StarburstY[i] >= 272 then
         StarNr = i
      end
   end
   
   if StarNr ~= -1 then
      StarburstX[StarNr] = Xpos
      StarburstY[StarNr] = Ypos
      
      StarburstVelY[StarNr] = - ( math.random() *4 +4)
      StarburstVelX[StarNr] = math.random() *10 -5
   end
end

function DrawStarburst()
   local StarTileX = 0
   local StarTileY = 0
   local StarTilePlatform = false
   
   for i = 1,20 do
      if StarburstY[i] < 272 then
         StarTileX = math.floor(StarburstX[i] /12)
         StarTileY = math.floor(StarburstY[i] /12)
         
         StarburstX[i] = StarburstX[i] + StarburstVelX[i]
         StarburstY[i] = StarburstY[i] + StarburstVelY[i]
         
         StarburstVelY[i] = StarburstVelY[i] +.7
         
         if (StarTileX ~= math.floor(StarburstX[i] /12)) or (StarTileY ~= math.floor(StarburstY[i] /12)) then
            
            if StarburstY[i] > 0 and StarburstY[i] < 141 then
               if StarburstX[i] > 0 and StarburstX[i] < 480 then
                  StarTilePlatform = IsPlatform(math.floor(StarburstX[i] /12),math.floor(StarburstY[i] /12))
                  if (StarTilePlatform == true) and Decide(5) then
                     StarburstY[i] = StarTileY * 12
                     StarburstVelY[i] = -2
                  end
               end
            end
                        
         end
         
         screen:blit(StarburstX[i], StarburstY[i], ImgBobStar,math.mod(i,3)*12 ,0 ,12 ,12 , true)
      end
   end
end

function NewParticle(PBob,PBobX,PBobY,PBobSize,PX,PY,PvX,PvY)
   local Pindex = -1
   
   for i= 0,MaxParticles do
      if ParticleActive[i] ~= true then Pindex = i end
   end
   
   if Pindex ~= -1 then
      ParticleActive[Pindex] = true
      ParticleX[Pindex] = PX
      ParticleY[Pindex] = PY
      ParticleVelX[Pindex] = PvX
      ParticleVelY[Pindex] = PvY
      ParticleBob[Pindex] = PBob
      ParticlePBobX[Pindex] = PBobX
      ParticlePBobY[Pindex] = PBobY
      ParticlePBobSize[Pindex] = PBobSize
      
   end   
end

function DrawParticles()
   
   for i = 1,MaxParticles do
      if ParticleActive[i] then
         if ParticleY[i] < 272 then
            
            ParticleX[i] = ParticleX[i] + ParticleVelX[i]
            ParticleY[i] = ParticleY[i] + ParticleVelY[i]
            
            ParticleVelY[i] = ParticleVelY[i] +.7
            
         else
            ParticleActive[i] = false
         end
         
         screen:blit(ParticleX[i] - ParticlePBobSize[i]/2, ParticleY[i] - ParticlePBobSize[i]/2, ParticleBob[i],ParticlePBobX[i] ,ParticlePBobY[i] ,ParticlePBobSize[i] ,ParticlePBobSize[i] , true)
      end
   end
end

function DrawBltFire()
   for i=0,19 do
      if BltFire[i] > 0 then
         local BltFireAnim = math.floor(BltFire[i]/4) - math.floor(BltFire[i]/8) *2
         if BltFire[i] < 10 then
            screen:blit(BltFireX[i]*12, BltFireY[i]*12, enemy[7].ImgAttack, (4+BltFireAnim) *12, 0, 12, 12, true)
         elseif BltFire[i] < 20 then
            screen:blit(BltFireX[i]*12, BltFireY[i]*12, enemy[7].ImgAttack, (2+BltFireAnim) *12, 0, 12, 12, true)
         else
            screen:blit(BltFireX[i]*12, BltFireY[i]*12, enemy[7].ImgAttack, (0+BltFireAnim) *12, 0, 12, 12, true)
         end
         BltFire[i] = BltFire[i] -1
         
         if (math.floor(PlayerXpos/12) == BltFireX[i]) and (math.floor(PlayerYpos/12) == BltFireY[i]) then
            if (PInvincible == 0) and (PHit == false) then
               PHit = true
               PlayerVelocityY = -5
            end
         end
      end
   end
end

function DrawBullet(BulletNr)
   if BulletUsed[BulletNr] then
      if BulletType[BulletNr] == 1 then
         if BulletDir[BulletNr] == 1 then
            BulletXpos[BulletNr] = BulletXpos[BulletNr] -6
         else
            BulletXpos[BulletNr] = BulletXpos[BulletNr] +6
         end
         
         BobSize = enemy[3].size
         EbobX = 2 + math.random(2)
         EbobY = BulletDir[BulletNr]
         screen:blit(BulletXpos[BulletNr] -(BobSize/2), BulletYpos[BulletNr] +12 -BobSize +1, enemy[3].ImgAttack, EbobX *BobSize, EbobY *BobSize, BobSize, BobSize, true)
         
         local CheckX = BulletXpos[BulletNr] - PlayerXpos
         local CheckY = BulletYpos[BulletNr] - PlayerYpos
         
         if (CheckX > -12) and (CheckX < 12) and  (CheckY > -10) and (CheckY < 10) then
            if PInvincible == 0 then
               PHit = true
               PlayerVelocityY = -5
            end
         end
      elseif BulletType[BulletNr] == 2 then
         if BulletDir[BulletNr] == 1 then
            BulletXpos[BulletNr] = BulletXpos[BulletNr] -BulletXvel[BulletNr]
         else
            BulletXpos[BulletNr] = BulletXpos[BulletNr] +BulletXvel[BulletNr]
         end
         BulletYpos[BulletNr] = BulletYpos[BulletNr] +BulletYvel[BulletNr]
         if BulletYvel[BulletNr] <5 then
            BulletYvel[BulletNr] = BulletYvel[BulletNr] +.5
         end
         
         BobSize = 12
         
         EbobX = 0
         EbobY = 0
         screen:blit(BulletXpos[BulletNr] -(BobSize/2), BulletYpos[BulletNr] -BobSize, enemy[7].ImgAttack, EbobX *BobSize, EbobY *BobSize, BobSize, BobSize, true)
         
         if BulletYvel[BulletNr] > 0 then
            local BltTileX = math.floor(BulletXpos[BulletNr]/12)
            local BltTileY = math.floor((BulletYpos[BulletNr]+2)/12)
            
            
            if BltTileY < 22 then
               if IsPlatform(BltTileX,BltTileY) then
                  BulletUsed[BulletNr] = false
                  SndFire:play()
                  
                  BltFire[BltFireNext] = 50
                  BltFireX[BltFireNext] = BltTileX
                  BltFireY[BltFireNext] = BltTileY-1
                  BltFireNext = BltFireNext+1
                  if BltFireNext == 20 then BltFireNext = 0 end
                  
                  for i=1,4 do
                     if IsPlatform(BltTileX-i,BltTileY) then
                        BltFire[BltFireNext] = 50-i*7
                        BltFireX[BltFireNext] = BltTileX-i
                        BltFireY[BltFireNext] = BltTileY-1
                        BltFireNext = BltFireNext+1
                        if BltFireNext == 20 then BltFireNext = 0 end
                     else
                        break
                     end
                  end
                  for i=1,4 do
                     if IsPlatform(BltTileX+i,BltTileY) then
                        BltFire[BltFireNext] = 50-i*7
                        BltFireX[BltFireNext] = BltTileX+i
                        BltFireY[BltFireNext] = BltTileY-1
                        BltFireNext = BltFireNext+1
                        if BltFireNext == 20 then BltFireNext = 0 end
                     else
                        break
                     end
                  end
               end
            else
               BulletUsed[BulletNr] = false
            end
         end
         
         local CheckX = BulletXpos[BulletNr] - PlayerXpos
         local CheckY = BulletYpos[BulletNr] - PlayerYpos
         
         if (CheckX > -12) and (CheckX < 12) and  (CheckY > -10) and (CheckY < 10) then
            if PInvincible == 0 then
               PHit = true
               PlayerVelocityY = -5
            end
         end
      end
   end
end

function DrawThrownEgg()
   if Pbombing == 1 then
      local TileYpos = math.floor((PEggYpos+11)/12)
      local TileXpos = math.floor((PEggXpos) /12)
      
      PEggYpos = PEggYpos + PEggVelocityY
      PEggXpos = PEggXpos + PEggVelocityX
      
      if PEggVelocityY <5 then
         PEggVelocityY = PEggVelocityY +1
      end
      
      if PEggVelocityY >0 then
         if TileYpos < math.floor((PEggYpos+11)/12) then
            if IsPlatform(TileXpos,TileYpos +1) then
               Pbombing = 0
               print ("Missed!")
               SndEgg:play()
               
               NewParticle (ImgBobEggsplash,48+12 ,0  ,12 ,PEggXpos +5,  PEggYpos +5 ,2    +PEggVelocityX/2 ,-1)
               NewParticle (ImgBobEggsplash,48+12 ,12 ,12 ,PEggXpos +9,  PEggYpos +5 ,3    +PEggVelocityX/2 ,-.5)
               NewParticle (ImgBobEggsplash,24+12 ,0  ,12 ,PEggXpos +7,  PEggYpos +5 ,3.5  +PEggVelocityX/2 ,0)
               NewParticle (ImgBobEggsplash,24+12 ,12 ,12 ,PEggXpos +6,  PEggYpos +5 ,2    +PEggVelocityX/2 ,.5)               
               NewParticle (ImgBobEggsplash,48    ,0  ,12 ,PEggXpos -4,  PEggYpos +5 ,-2.5 +PEggVelocityX/2 ,-1.1)               
               NewParticle (ImgBobEggsplash,48    ,12 ,12 ,PEggXpos -10, PEggYpos +5 ,-3.2 +PEggVelocityX/2 ,-.5)
               NewParticle (ImgBobEggsplash,24    ,12 ,12 ,PEggXpos -7,  PEggYpos +5 ,-1.8 +PEggVelocityX/2 ,.6)
               NewParticle (ImgBobEggsplash,0     ,0  ,12 ,PEggXpos     ,PEggYpos    ,.3   +PEggVelocityX/2 ,-.2)
            end
         end
      end
      
      for i=0,Enemies -1 do
         if EnemyDead[i] == false then
            EType = EnemyType[i]
            if (PEggYpos < EnemyYpos[i]) and (PEggYpos > EnemyYpos[i] -20) then
               if (EnemyXpos[i] > PEggXpos -20) and (EnemyXpos[i] < PEggXpos +20) then
                  EnemyAction[i] = 3
                  EnemyDead[i] = true
                  EnemiesLiving = EnemiesLiving -1
                  
                  Pbombing = 0
                  print ("In air hit on enemy " .. i .. ": killed")
                  SndEgg:play()
                  
                  NewParticle (ImgBobEggsplash,48+12 ,0  ,12 ,PEggXpos +5,  PEggYpos +5 ,2    +PEggVelocityX/2 ,-1)
                  NewParticle (ImgBobEggsplash,48+12 ,12 ,12 ,PEggXpos +9,  PEggYpos +5 ,3    +PEggVelocityX/2 ,-.5)
                  NewParticle (ImgBobEggsplash,24+12 ,0  ,12 ,PEggXpos +7,  PEggYpos +5 ,3.5  +PEggVelocityX/2 ,0)
                  NewParticle (ImgBobEggsplash,24+12 ,12 ,12 ,PEggXpos +6,  PEggYpos +5 ,2    +PEggVelocityX/2 ,.5)               
                  NewParticle (ImgBobEggsplash,48    ,0  ,12 ,PEggXpos -4,  PEggYpos +5 ,-2.5 +PEggVelocityX/2 ,-1.1)               
                  NewParticle (ImgBobEggsplash,48    ,12 ,12 ,PEggXpos -10, PEggYpos +5 ,-3.2 +PEggVelocityX/2 ,-.5)
                  NewParticle (ImgBobEggsplash,24    ,12 ,12 ,PEggXpos -7,  PEggYpos +5 ,-1.8 +PEggVelocityX/2 ,.6)
                  NewParticle (ImgBobEggsplash,0     ,0  ,12 ,PEggXpos     ,PEggYpos    ,.3   +PEggVelocityX/2 ,-.2)               
                  
                  NewAddedPoints(EnemyXpos[i],EnemyYpos[i],50)
                  NewFruit(EnemyXpos[i],EnemyYpos[i],PEggVelocityX/8,-3 -math.random(8),math.random(7)-1)
                  
                  if EnemiesLiving == 0 then UnlockDoor() end
               end
            end
         end
      end
      screen:blit(PEggXpos -12, PEggYpos -12, ImgBobEgg, 2*24 , 0, 24, 24, true)                  
   end
end

function DrawPlayer()
   if GameRunning == false then 
      return
   end
   
   local BobsImg = ImgBobChipke
   local BobsSize = 24
   local BobYShift = 0
   
   if PHit == true then
      if PEgg then
         PEgg = false
      end
      
      PbobY = 1
      PlayerAnimFrame = PlayerAnimFrame +1
      
      PlayerYpos = PlayerYpos + PlayerVelocityY
      PlayerXpos = PlayerXpos + PlayerVelocityX
      
      if PlayerVelocityY <10 then
         PlayerVelocityY = PlayerVelocityY +1
      end
      
      if PlayerAnimFrame == 1 then
         PbobX = 12
      elseif PlayerAnimFrame == 2 then
         PbobX = 14
      elseif PlayerAnimFrame == 3 then
         PbobX = 13
      else
         PbobX = 14
         PlayerAnimFrame = 0
      end
      
      if PlayerYpos > 272 then
         PlayerXpos = PinitX
         PlayerYpos = PinitY
         
         PInvincible = 50
         PlayerVelocityY = 0
         Pdir = 0
         PHit = false         
         Pladder = false
         Pjump = false
         PEgg = false
         Pplatform = -1
         
         Lives = Lives -1
         if Lives == -1 then GameRunning = false end
      end
      
   elseif Pladder == true then
      
      PbobY = 0
      
      if PlayerAnimFrame == 1 then
         PbobX = 12
      elseif PlayerAnimFrame == 2 then
         PbobX = 14
      elseif PlayerAnimFrame == 3 then
         PbobX = 13
      else
         PbobX = 14
         PlayerAnimFrame = 0
      end
   elseif Pjump == false then      
      if Pplatform ~= -1 then
         PlayerYpos = ( PlatformY[Pplatform] *12 ) - PlatformElevation[Pplatform] -12
      end
      
      PlayerAnimFrame = PlayerAnimFrame +1
      if Pmove == 1 or Pmove == 3 then
         if PlayerAnimFrame == 1 then
            PbobX = 2
         elseif PlayerAnimFrame == 2 then
            PbobX = 3
         elseif PlayerAnimFrame == 3 then
            PbobX = 4
         elseif PlayerAnimFrame == 4 then
            PbobX = 5
         elseif PlayerAnimFrame == 5 then
            PbobX = 6
         elseif PlayerAnimFrame == 6 then
            PbobX = 7
         elseif PlayerAnimFrame == 7 then
            PbobX = 8
         else
            PbobX = 1
            PlayerAnimFrame = 0
         end
      else
         PbobX = 0         
      end
      PbobY = Pdir   
   else
      if Pplatform ~= -1 then
         PlayerYpos = ( PlatformY[Pplatform] *12 ) - PlatformElevation[Pplatform] -12
      end
      
      if PlayerAnimFrame == 0 then
         PbobX = 9
         PlayerAnimFrame = 1
      elseif  PlayerAnimFrame == 1 then
         PbobX = 10
         PlayerAnimFrame = 2
         PlayerVelocityY = -7
         Pplatform = -1
      else
         local TileYpos = math.floor((PlayerYpos+11)/12)
         local TileXpos = math.floor((PlayerXpos) /12)
         
         PlayerYpos = PlayerYpos + PlayerVelocityY
         if PlayerVelocityY <5 then
            PlayerVelocityY = PlayerVelocityY +1
         end
         
         if PlayerVelocityY <0 then
            PbobX = 10
         else
            PbobX = 11
            
            if TileYpos < math.floor((PlayerYpos+11)/12) then
               if IsPlatform(TileXpos,TileYpos +1) then
                  PlayerYpos = (TileYpos) *12
                  Pjump = false
                  PlayerVelocityY = 0
               end   
            end
         end
         
         if PlatformsUsed > 0 then
            for i= 0,PlatformsUsed -1 do
               if (TileXpos >= PlatformX[i]) and (TileXpos < PlatformX[i]+3) then
                  local ElevY = (PlatformY[i]*12) -PlatformElevation[i] -12
                  if (PlayerYpos >= ElevY) and (PlayerYpos < ElevY+12) then
                     Pplatform = i
                     Pjump = false
                     PlayerVelocityY = 0
                     PlayerYpos = ElevY
                  end
               end
            end
         end
      end
      
      PbobY = Pdir
   end
   
   if PInvincible ~= 0 then
      if math.mod(math.floor(PInvincible/2),2) == 0 then
         screen:blit(PlayerXpos -(BobsSize/2), PlayerYpos +12 -BobsSize +BobYShift, BobsImg,PbobX*BobsSize ,PbobY*BobsSize ,BobsSize ,BobsSize , true)
      end
      
      PInvincible = PInvincible -1
   else
      if PEgg then
         screen:blit(PlayerXpos -(BobsSize/2), PlayerYpos -BobsSize +BobYShift, ImgBobEgg,2*BobsSize ,0*BobsSize ,BobsSize ,BobsSize , true)
         screen:blit(PlayerXpos -(BobsSize/2), PlayerYpos +12 -BobsSize +BobYShift, ImgBobChipkeEgg,PbobX*BobsSize ,PbobY*BobsSize ,BobsSize ,BobsSize , true)         
      else
         screen:blit(PlayerXpos -(BobsSize/2), PlayerYpos +12 -BobsSize +BobYShift, BobsImg,PbobX*BobsSize ,PbobY*BobsSize ,BobsSize ,BobsSize , true)
      end
   end
end

function DrawEnemy(IndexNr)
   
   local EType = EnemyType[IndexNr]
   local BobSize = enemy[EType].size
   
   local EDizzy = 10
   
   if EnemyDead[IndexNr] then
      return 0
   end
   
   if enemy[EType].Movement == 1 then
      if FreezeEnemies > 0 then
         
         EbobX = math.floor(EnemyAnimFrame[IndexNr] /3 )
         EbobY = EnemyDir[IndexNr]
         
      elseif EnemyAction[IndexNr] == 0 then -- walk
         EnemyAnimFrame[IndexNr] = EnemyAnimFrame[IndexNr] +1   
         if EnemyAnimFrame[IndexNr] == 12 then EnemyAnimFrame[IndexNr] = 0 end
         
         if EnemyDir[IndexNr] == 0 then
            EnemyXpos[IndexNr] = EnemyXpos[IndexNr] +enemy[EType].step
            
            local InFrontX = math.floor((EnemyXpos[IndexNr] +1 +12) /12)
            local InFrontY = math.floor((EnemyYpos[IndexNr] +12) /12)
            
            if EnemyXpos[IndexNr] >= 480 -12 then
               EnemyDir[IndexNr] = 1
            elseif IsPlatform(InFrontX,InFrontY) == false then
               EnemyDir[IndexNr] = 1
            end
            
         else
            EnemyXpos[IndexNr] = EnemyXpos[IndexNr] -enemy[EType].step
            
            local InFrontX = math.floor((EnemyXpos[IndexNr] -12) /12)
            local InFrontY = math.floor((EnemyYpos[IndexNr] +12) /12)
            
            if EnemyXpos[IndexNr] <= 12 then
               EnemyDir[IndexNr] = 0
            elseif IsPlatform(InFrontX,InFrontY) == false then
               EnemyDir[IndexNr] = 0
            end
         end
         
         EbobX = math.floor( EnemyAnimFrame[IndexNr] /3 )
         EbobY = EnemyDir[IndexNr]
         
         if enemy[EType].climb then
            for i=0,Ladders -1 do
               if (EnemyXpos[IndexNr] == LadderXpos[i]*12 +12) and (EnemyYpos[IndexNr] == LadderYpos[i]*12) then
                  if Decide(2) then
                     EnemyAction[IndexNr] = 1
                     EnemyAnimFrame[IndexNr] = 0
                     EnemyLadder[IndexNr] = i
                  end
               end
               if (EnemyXpos[IndexNr] == LadderXpos[i]*12 +12) and (EnemyYpos[IndexNr] == (LadderYpos[i]-4)*12) then
                  if Decide(2) then
                     EnemyAction[IndexNr] = 2
                     EnemyAnimFrame[IndexNr] = 0
                     EnemyLadder[IndexNr] = i
                  end
               end
            end
         end
         if (enemy[EType].attack ~= 0) and EnemyAction[IndexNr] == 0 then
            if EnemyYpos[IndexNr] == PlayerYpos then
               if ((EnemyDir[IndexNr] == 0) and (PlayerXpos > EnemyXpos[IndexNr] + 48)) or ((EnemyDir[IndexNr] == 1) and (PlayerXpos < EnemyXpos[IndexNr] - 48)) then
                  local Freebullet = -1
                  for i=0,MaxBullets -1 do
                     if BulletUsed[i] == false then
                        Freebullet = i
                     end
                  end            
                  
                  if (Decide(50) and (Freebullet ~= -1)) then
                     -- do attack
                     print (IndexNr .. " attack " .. math.random(100))
                     EnemyAction[IndexNr] = 4
                     EnemyAnimFrame[IndexNr] = 0
                     
                     EbobX = 0
                     EbobY = EnemyDir[IndexNr]                                                
                  end
               end
            end
         end
      elseif EnemyAction[IndexNr] == 1 then -- climb up
         EnemyAnimFrame[IndexNr] = EnemyAnimFrame[IndexNr] +1
         if EnemyAnimFrame[IndexNr] == 8 then EnemyAnimFrame[IndexNr] = 0 end
         
         EnemyYpos[IndexNr] = EnemyYpos[IndexNr] -3
         
         EbobX = math.floor(EnemyAnimFrame[IndexNr] /2)
         EbobY = 4
         
         if (EnemyYpos[IndexNr] == (LadderYpos[EnemyLadder[IndexNr]]-4)*12) then
            EnemyAction[IndexNr] = 0
            
            local EXPos = math.floor(EnemyXpos[IndexNr] /12)-1
            local EYPos = math.floor(EnemyYpos[IndexNr] /12)
            
            if IsPlatform(EXPos,EYPos+1) == false then         
               for i=0,Ladders -1 do
                  if (EnemyXpos[IndexNr] == LadderXpos[i]*12 +12) and (EnemyYpos[IndexNr] == LadderYpos[i]*12) then
                     EnemyAction[IndexNr] = 1
                     EnemyAnimFrame[IndexNr] = 0
                     EnemyLadder[IndexNr] = i
                  end
               end
               if EnemyAction[IndexNr] == 0 then
                  EnemyAction[IndexNr] = 2
               end
            else
               for i=0,Ladders -1 do
                  if (EnemyXpos[IndexNr] == LadderXpos[i]*12 +12) and (EnemyYpos[IndexNr] == LadderYpos[i]*12) then
                     if Decide(2) then
                        EnemyAction[IndexNr] = 1
                        EnemyAnimFrame[IndexNr] = 0
                        EnemyLadder[IndexNr] = i
                     end
                  end
               end
            end
         end
      elseif EnemyAction[IndexNr] == 2 then -- climb down
         EnemyAnimFrame[IndexNr] = EnemyAnimFrame[IndexNr] +1
         if EnemyAnimFrame[IndexNr] == 8 then EnemyAnimFrame[IndexNr] = 0 end
         
         EnemyYpos[IndexNr] = EnemyYpos[IndexNr] +3
         
         EbobX = math.floor(EnemyAnimFrame[IndexNr] /2)
         EbobY = 4
         
         if (EnemyYpos[IndexNr] == LadderYpos[EnemyLadder[IndexNr]]*12) then
            EnemyAction[IndexNr] = 0
            
            local EXPos = math.floor(EnemyXpos[IndexNr] /12)-1
            local EYPos = math.floor(EnemyYpos[IndexNr] /12)
            
            if IsPlatform(EXPos,EYPos+1) == false then         
               for i=0,Ladders -1 do
                  if (EnemyXpos[IndexNr] == LadderXpos[i]*12 +12) and (EnemyYpos[IndexNr] == (LadderYpos[i]-4)*12) then
                     EnemyAction[IndexNr] = 2
                     EnemyAnimFrame[IndexNr] = 0
                     EnemyLadder[IndexNr] = i
                  end
               end
               if EnemyAction[IndexNr] == 0 then
                  EnemyAction[IndexNr] = 1
               end
            else
               for i=0,Ladders -1 do
                  if (EnemyXpos[IndexNr] == LadderXpos[i]*12 +12) and (EnemyYpos[IndexNr] == (LadderYpos[i]-4)*12) then
                     if Decide(2) then
                        EnemyAction[IndexNr] = 2
                        EnemyAnimFrame[IndexNr] = 0
                        EnemyLadder[IndexNr] = i
                     end
                  end
               end
            end
         end
      elseif EnemyAction[IndexNr] == 3 then -- hit
         EnemyAnimFrame[IndexNr] = EnemyAnimFrame[IndexNr] +1
         
         if EnemyAnimFrame[IndexNr] < 40 then
            EDizzy = math.floor(math.mod(EnemyAnimFrame[IndexNr],6)/2)
         elseif EnemyAnimFrame[IndexNr] > 50 then
            EnemyAction[IndexNr] = 0
            EnemyAnimFrame[IndexNr] = 0
         end
         
         EbobX = math.floor(EnemyAnimFrame[IndexNr] /2)
         EbobY = 2 +EnemyDir[IndexNr]
         
         if EbobX > 3 then EbobX = 3 end
      elseif EnemyAction[IndexNr] == 4 then -- Attack
         if (enemy[EType].attack == 1) then
            EnemyAnimFrame[IndexNr] = EnemyAnimFrame[IndexNr] +1
            
            if EnemyAnimFrame[IndexNr] > 15 then         
               EnemyAction[IndexNr] = 0
               EnemyAnimFrame[IndexNr] = 0
            end
            
            EbobX = math.floor(EnemyAnimFrame[IndexNr] /2)
            EbobY = EnemyDir[IndexNr]
            
            if EbobX > 2 then EbobX = 2 end
            
            if EnemyAnimFrame[IndexNr] == 4 then
               local Freebullet = -1
               for i=0,MaxBullets -1 do
                  if BulletUsed[i] == false then
                     Freebullet = i
                  end
               end
               if Freebullet ~= -1 then
                  BulletUsed[Freebullet] = true
                  BulletXpos[Freebullet] = EnemyXpos[IndexNr]
                  BulletYpos[Freebullet] = EnemyYpos[IndexNr]
                  BulletDir[Freebullet] = EnemyDir[IndexNr]
                  BulletType[Freebullet] = enemy[EType].attack
                  
                  SndFire:play()
               end
            end
         elseif (enemy[EType].attack == 2) then
            EnemyAnimFrame[IndexNr] = EnemyAnimFrame[IndexNr] +1
            
            EbobX = 0
            EbobY = EnemyDir[IndexNr]
            
            if EnemyAnimFrame[IndexNr] == 3 then
               local Freebullet = -1
               for i=0,MaxBullets -1 do
                  if BulletUsed[i] == false then
                     Freebullet = i
                  end
               end
               
               if Freebullet ~= -1 then
                  BulletUsed[Freebullet] = true
                  BulletXpos[Freebullet] = EnemyXpos[IndexNr]
                  BulletYpos[Freebullet] = EnemyYpos[IndexNr]
                  BulletXvel[Freebullet] = 7
                  BulletYvel[Freebullet] = -3
                  BulletDir[Freebullet] = EnemyDir[IndexNr]
                  BulletType[Freebullet] = enemy[EType].attack
               end
            elseif EnemyAnimFrame[IndexNr] == 15 then
               EnemyAction[IndexNr] = 0
               EnemyAnimFrame[IndexNr] = 0
            end
         end
      end
   elseif enemy[EType].Movement == 2 then
      EnemyAnimFrame[IndexNr] = EnemyAnimFrame[IndexNr] +1
      if EnemyAnimFrame[IndexNr] == 8 then EnemyAnimFrame[IndexNr] = 0 end
      
      if EnemyDir[IndexNr] == 0 then
         EnemyXpos[IndexNr] = EnemyXpos[IndexNr] +enemy[EType].step
         EnemyYpos[IndexNr] = EnemyYpos[IndexNr] -enemy[EType].step/3
      elseif EnemyDir[IndexNr] == 1 then
         EnemyXpos[IndexNr] = EnemyXpos[IndexNr] +enemy[EType].step
         EnemyYpos[IndexNr] = EnemyYpos[IndexNr] +enemy[EType].step/3
      elseif EnemyDir[IndexNr] == 2 then
         EnemyXpos[IndexNr] = EnemyXpos[IndexNr] -enemy[EType].step
         EnemyYpos[IndexNr] = EnemyYpos[IndexNr] -enemy[EType].step/3
      elseif EnemyDir[IndexNr] == 3 then
         EnemyXpos[IndexNr] = EnemyXpos[IndexNr] -enemy[EType].step
         EnemyYpos[IndexNr] = EnemyYpos[IndexNr] +enemy[EType].step/3
      end
      
      if EnemyXpos[IndexNr] >= 480 -12 then
         if EnemyDir[IndexNr] == 0 then EnemyDir[IndexNr] = 2 end
         if EnemyDir[IndexNr] == 1 then EnemyDir[IndexNr] = 3 end
      end
      if EnemyXpos[IndexNr] <= 12 then
         if EnemyDir[IndexNr] == 2 then EnemyDir[IndexNr] = 0 end
         if EnemyDir[IndexNr] == 3 then EnemyDir[IndexNr] = 1 end
      end
      if EnemyYpos[IndexNr] >= 272 -12 then
         if EnemyDir[IndexNr] == 1 then EnemyDir[IndexNr] = 0 end
         if EnemyDir[IndexNr] == 3 then EnemyDir[IndexNr] = 2 end
      end
      if EnemyYpos[IndexNr] <= 12 then
         if EnemyDir[IndexNr] == 0 then EnemyDir[IndexNr] = 1 end
         if EnemyDir[IndexNr] == 2 then EnemyDir[IndexNr] = 3 end
      end
      
      EbobX = math.floor( EnemyAnimFrame[IndexNr] /2 )
      EbobY = math.floor( EnemyDir[IndexNr] /2 )
   end
   
   if EnemyAction[IndexNr] ~= 4 then
      EImage = enemy[EType].ImgBob
   else
      if enemy[EType].attack == 1 then
         EImage = enemy[EType].ImgAttack
      else
         EImage = enemy[EType].ImgBob  
      end
   end
   
   if EnemyLife[IndexNr] then
      screen:blit(EnemyXpos[IndexNr] -(BobSize/2), EnemyYpos[IndexNr] +12 -BobSize +1, EImage, EbobX *BobSize, EbobY *BobSize, BobSize, BobSize, true)
   end
   
   if EDizzy ~= 10 then screen:blit(EnemyXpos[IndexNr] -16, EnemyYpos[IndexNr] -BobSize +6, ImgBobDizzy, EDizzy *32, 0, 32, 12, true) end
end

function Decide(Rarity)
   local seed = math.random(Rarity)
   if seed == math.random(Rarity) then
      return true
   else
      return false
   end
end

function FileExist(Path,Filename)
   Myfiles = System.listDirectory(Path)
   for i=1, table.getn(Myfiles) do      
      if string.lower(Myfiles[i].name) == string.lower(Filename) then
         return true
      end
   end
   return false
end

function CheckLevelExist(LevNr)
   return FileExist("data/","level" .. LevNr .. ".lvl")
end

function NextLevel()
   Level = Level +1
   if Level > 1 then
      ImgLevel:blit(DoorX *12 -12, DoorY *12 -24, ImgDoor,DoorState *36 ,0 ,36 ,36 , true)
   end
   
   -- Load Leveldata
   LoadLevel ("data/level" .. Level .. ".lvl")
   ImgTiles = Image.load(TilesFile)   
   ImgBg = Image.load(BGFile)   
   
   ImgOldLevel = Image.createEmpty(480,272)
   ImgOldLevel:blit(0,0,ImgLevel,false)
   
   -- DrawLevel
   DrawLevel()
   SetObjProps()
   
   if Level > 1 then
      for i=1,80 do
         j= 136-math.floor(math.cos((math.pi/80)*i)*136)
         screen:blit(0,0,ImgLevel,0,272-j,480,j,false)
         screen:blit(0,j,ImgOldLevel,0,0,480,272-j,false)
         screen.flip()
         screen.waitVblankStart(1)
      end
      ImgOldLevel=nil
   end
   
   local world = math.floor((Level-1)/3)
   local stage = Level - (world*3)
   
   Message = "STAGE " .. world+1 .. " - " .. stage
   MessageSub = ""
   
   MessageCountdown = 30
end

function LoadLevel(DatFile)
   GameField = {}
   
   local BlockProp = 0
   
   BlockPlatform = {}
   BlockCollide = {}
   BlockHit = {}
   BlockSlip = {}
   
   ObjProps = {}
   ObjProps.count = 0
   
   LevFile = io.open(DatFile, "rb")

      for i = 1,22 do
         GameField[i] = LevFile:read(40)
      end
      for i = 0,255 do
         BlockProp = string.byte( LevFile:read(1) )
         
         BlockPlatform[i] = IsBitSet(BlockProp,1)
         BlockCollide[i] = IsBitSet(BlockProp,2)
         BlockHit[i] = IsBitSet(BlockProp,3)
         BlockSlip[i] = IsBitSet(BlockProp,4)
      end
      
      local NextByte      
      NextByte = LevFile:read(1)
      if (NextByte ~= nil) then
         local NewTiles = ""
         while string.byte( NextByte ) ~= 0 do
            NewTiles = NewTiles .. NextByte
            NextByte = LevFile:read(1)
         end
         
         if NewTiles ~= "" then
            TilesFile = "images/" .. NewTiles
         end
      end
      
      NextByte = LevFile:read(1)
      if (NextByte ~= nil) then
         local NewBG = ""
         while string.byte( NextByte ) ~= 0 do
            NewBG = NewBG .. NextByte
            NextByte = LevFile:read(1)
         end
         
         if NewBG ~= "" then
            BGFile = "images/" .. NewBG
         end
      end

      NextByte = LevFile:read(1)
      if (NextByte ~= nil) then
        while (string.byte( NextByte ) ~= 255) do
           ObjProps[ObjProps.count] = string.byte( NextByte )
           ObjProps.count = ObjProps.count +1
           NextByte = LevFile:read(1)
           if NextByte == nil then break end
        end
      end
   LevFile:close()
end

function IsBitSet(SValue,Bit)
   if math.floor(((SValue / (2^Bit)) - math.floor(SValue / (2^Bit))) * 2) == 1 then   
      return true
   else
      return false
   end
end

function CheckCollision()
   local CollideMinX = PlayerXpos -12
   local CollideMinY = PlayerYpos -16
   local CollideMaxX = PlayerXpos +12
   local CollideMaxY = PlayerYpos +16
   
   local EType = 0
   
   if PHit == false then
      for i=0,Enemies -1 do
         if EnemyAction[i] ~= 3 then
            EType = EnemyType[i]
            CollideMaxY = PlayerYpos + enemy[EType].CollideMaxY
            
            if (EnemyXpos[i] > CollideMinX) and (EnemyXpos[i] < CollideMaxX) then
               if (EnemyYpos[i] > CollideMinY) and (EnemyYpos[i] < CollideMaxY) then
                  if (PlayerVelocityY > 0) and (PlayerYpos < EnemyYpos[i] -10) and (Pjump == true) and (EnemyAction[i] ~= 1) and (EnemyAction[i] ~= 2) and (enemy[EType].NoStun == false) then
                     EnemyAction[i] = 3
                     PlayerVelocityY = -3
                     EnemyAnimFrame[i] = 0
                     SndBounce:play()
                     NewAddedPoints(EnemyXpos[i],EnemyYpos[i] -5,10)
                  elseif PInvincible == 0 then
                     if popeye then
                        EnemyAction[i] = 3
                        PlayerVelocityY = -3
                        EnemyAnimFrame[i] = 0
                        SndBounce:play()
                     elseif toxic then
                        EnemyAction[i] = 3
                        EnemyDead[i] = true
                        EnemiesLiving = EnemiesLiving -1
                        
                        local EType = EnemyType[i]
                        local ESize = enemy[EType].size
                        NewParticle (enemy[EType].ImgBob,3*ESize,(EnemyDir[i]+2)*ESize,ESize,EnemyXpos[i],EnemyYpos[i],2 -Pdir*4,-2 -math.random(7))
                        
                        NewAddedPoints(EnemyXpos[i],EnemyYpos[i],50)
                        NewFruit(EnemyXpos[i],EnemyYpos[i]-20,2 -Pdir*4,-3 -math.random(5),math.random(7)-1)
                        
                        if EnemiesLiving == 0 then UnlockDoor() end
                     else
                        print ("Collided with enemy: " .. i )
                        PHit = true
                        PlayerVelocityY = -5
                     end
                  end
               end
            end
         end
      end
      
      local TileXpos = math.floor((PlayerXpos)/12)
      local TileYpos = math.floor((PlayerYpos + 11)/12)
      
      if IsHit(TileXpos,TileYpos) then      
         print ("Collided with Background")
         PHit = true
         PlayerVelocityY = -5
      end
   end
end

function DrawLevel()
   ImgLevel:blit(0, 0, ImgBg, false)
   
   local TileNr
   local TileXpos
   local TileYpos
   
   StarburstX = nil
   StarburstY = nil
   StarburstVelY = nil
   StarburstVelX = nil
   
   StarburstX = {}
   StarburstY = {}
   StarburstVelY = {}
   StarburstVelX = {}
   
   for i = 1,20 do
      StarburstX[i] = 0
      StarburstY[i] = 300      
      StarburstVelY[i] = 0
      StarburstVelX[i] = 0
   end
   
   BltFire = nil
   BltFireX = nil
   BltFireY = nil   
   
   BltFireNext =0
   BltFire = {}
   BltFireX = {}
   BltFireY = {}   
   for i = 0,19 do
      BltFire[i] = 0
      BltFireX[i] = 0
      BltFireY[i] = 0
   end
   
   Ladders = 0
   LadderXpos = nil
   LadderYpos = nil
   
   LadderXpos = {}
   LadderYpos = {}
   
   DoorX = 0
   DoorY = 0
   DoorState = 0
   DoorOpen = false
   
   KeyX = 0
   KeyY = 0
   KeyCountdown = 0
   
   Enemies = 0
   EnemiesLiving = 0
   EnemyXpos = nil
   EnemyYpos = nil
   EnemyType = nil
   EnemyAction = nil
   EnemyAnimFrame = nil
   EnemyDir = nil
   EnemyDead = nil
   
   EnemyXpos = {}
   EnemyYpos = {}
   EnemyType = {}
   EnemyAction = {}
   EnemyAnimFrame = {}
   EnemyDir = {}
   EnemyLadder = {}
   EnemyLife = {}
   EnemyDead = {}
   
   PlayerXpos = 0
   PlayerYpos = 0
   PlayerSlide = 0
   
   PlayerAnimFrame = 0
   PlayerVelocityX = 0
   PlayerVelocityY = 0
   
   PEgg = false
   Pmove = 0
   PmoveOld = 0
   Pjump = false
   Pdir = 0
   Pladder = false
   Pplatform = -1
   PHit = false
   PInvincible = 50
   PinitX = 0
   PinitY = 0
   
   PEggXpos = 0
   PEggYpos = 0
   PEggVelocityX = 0
   PEggVelocityY = 0
   Pbombing = 0
   
   MaxBullets = 10
   BulletUsed = {}
   BulletXpos = {}
   BulletYpos = {}
   BulletXvel = {}
   BulletYvel = {}
   BulletDir = {}
   BulletType = {}
   for i = 0,MaxBullets -1 do
      BulletUsed[i] = false
      BulletXpos[i] = 0
      BulletYpos[i] = 0
      BulletXvel[i] = 0
      BulletYvel[i] = 0
      BulletDir[i] = 0
      BulletType[i] = 0
   end
   
   MaxEggSpowners = 10
   EggSpownersUsed = 0
   EggSpownerX = {}
   EggSpownerY = {}
   EggSpownerState = {}
   EggHatchtime = 500
   EggShellExploX = {}
   EggShellExploY = {}
   EggShellFall = {}
   
   EggSpownerActive = 30+math.floor(math.random()*50)
   EggSpownerNext = 0
   
   MaxParticles = 10
   ParticleActive = {}
   ParticleX = {}
   ParticleY = {}
   ParticleVelX = {}
   ParticleVelY = {}
   ParticleBob = {}
   ParticlePBobY = {}
   ParticlePBobX = {}
   ParticlePBobSize = {}
   
   PlatformX = {}
   PlatformY = {}
   PlatformElevation = {}
   PlatformDir = {}
   PlatformsUsed = 0
   
   ExitLevelCountdown = 1000
   FreezeEnemies = 45
   
   Message = ""
   MessageSub = ""
   MessageCountdown = 0
   
   PGotKey = false
   DropChest= 0
   Chest = {}
   Chest.VelY = 0
   Chest.PosY = -48
   Chest.PosX = 240
   Chest.DestY = 19*12
   
   APoints = {}
   Coins = {}
   Fruit = {}
   
   for j= 0,21 do
      for i= 0,39 do
         TileNr = ReadTile(i,j)
         TileYpos = math.floor(TileNr/16)
         TileXpos = TileNr - (TileYpos*16)
         
         if TileNr == 64 then -- ladder
            LadderXpos[Ladders] = i
            LadderYpos[Ladders] = j
            Ladders = Ladders +1
            WriteTile(i,j,255)
         elseif TileNr == 237 then -- Platform
            PlatformX[PlatformsUsed] = i
            PlatformY[PlatformsUsed] = j
            
            PlatformElevation[PlatformsUsed] = 0
            PlatformDir[PlatformsUsed] = 0
            
            PlatformsUsed = PlatformsUsed +1
            WriteTile(i,j,255)
            
         elseif TileNr == 241 then -- Door (EXIT)
            DoorX = i
            DoorY = j
            
            WriteTile(i,j,255)
         elseif TileNr == 242 then -- Key
            KeyX = i
            KeyY = j
            KeyCountdown = 1250
            
            WriteTile(i,j,255) 
         elseif TileNr == 240 then -- Egg Spowner
            if EggSpownersUsed < MaxEggSpowners then
               EggSpownerX[EggSpownersUsed] = i
               EggSpownerY[EggSpownersUsed] = j
               EggSpownerState[EggSpownersUsed] = 0
               EggSpownersUsed = EggSpownersUsed +1
            end
            WriteTile(i,j,255)
         elseif TileNr == 253 then -- Enemy Turtle
            EnemyXpos[Enemies] = i *12 +6
            EnemyYpos[Enemies] = j *12
            EnemyType[Enemies] = 1
            EnemyAction[Enemies] = 0
            EnemyAnimFrame[Enemies] = 0
            EnemyDir[Enemies] = 0
            EnemyLife[Enemies] = true
            EnemyDead[Enemies] = false
            
            Enemies = Enemies +1
            EnemiesLiving = EnemiesLiving +1
            WriteTile(i,j,255)
            
         elseif TileNr == 252 then -- Enemy Monkey
            EnemyXpos[Enemies] = i *12 +6
            EnemyYpos[Enemies] = j *12
            EnemyType[Enemies] = 2
            EnemyAction[Enemies] = 0
            EnemyAnimFrame[Enemies] = 0
            EnemyDir[Enemies] = 0
            EnemyLife[Enemies] = true
            EnemyDead[Enemies] = false
            
            Enemies = Enemies +1
            EnemiesLiving = EnemiesLiving +1
            WriteTile(i,j,255)
            
         elseif TileNr == 251 then -- Enemy Croc
            EnemyXpos[Enemies] = i *12 +6
            EnemyYpos[Enemies] = j *12
            EnemyType[Enemies] = 3
            EnemyAction[Enemies] = 0
            EnemyAnimFrame[Enemies] = 0
            EnemyDir[Enemies] = 0
            EnemyLife[Enemies] = true
            EnemyDead[Enemies] = false
            
            Enemies = Enemies +1
            EnemiesLiving = EnemiesLiving +1
            WriteTile(i,j,255)
            
         elseif TileNr == 250 then -- Enemy Snale
            EnemyXpos[Enemies] = i *12 +6
            EnemyYpos[Enemies] = j *12
            EnemyType[Enemies] = 4
            EnemyAction[Enemies] = 0
            EnemyAnimFrame[Enemies] = 0
            EnemyDir[Enemies] = 0
            EnemyLife[Enemies] = true
            EnemyDead[Enemies] = false
            
            Enemies = Enemies +1
            EnemiesLiving = EnemiesLiving +1
            WriteTile(i,j,255)
            
         elseif TileNr == 249 then -- Enemy Pinky
            EnemyXpos[Enemies] = i *12 +6
            EnemyYpos[Enemies] = j *12
            EnemyType[Enemies] = 5
            EnemyAction[Enemies] = 0
            EnemyAnimFrame[Enemies] = 0
            EnemyDir[Enemies] = 0
            EnemyLife[Enemies] = true
            EnemyDead[Enemies] = false
            
            Enemies = Enemies +1
            EnemiesLiving = EnemiesLiving +1
            WriteTile(i,j,255)
            
         elseif TileNr == 248 then -- Enemy Mad Turtle
            EnemyXpos[Enemies] = i *12 +6
            EnemyYpos[Enemies] = j *12
            EnemyType[Enemies] = 6
            EnemyAction[Enemies] = 0
            EnemyAnimFrame[Enemies] = 0
            EnemyDir[Enemies] = 0
            EnemyLife[Enemies] = true
            EnemyDead[Enemies] = false
            
            Enemies = Enemies +1
            EnemiesLiving = EnemiesLiving +1
            WriteTile(i,j,255)
            
         elseif TileNr == 247 then -- Enemy Sparky
            EnemyXpos[Enemies] = i *12 +6
            EnemyYpos[Enemies] = j *12
            EnemyType[Enemies] = 7
            EnemyAction[Enemies] = 0
            EnemyAnimFrame[Enemies] = 0
            EnemyDir[Enemies] = 0
            EnemyLife[Enemies] = true
            EnemyDead[Enemies] = false
            
            Enemies = Enemies +1
            EnemiesLiving = EnemiesLiving +1
            WriteTile(i,j,255)
                        
         elseif TileNr == 254 then -- PlayerPos
            PlayerXpos = i * 12 + 6
            PlayerYpos = j * 12
            WriteTile(i,j,255)
         else
            ImgLevel:blit(i*12,j*12, ImgTiles,TileXpos*12,TileYpos*12,12,12, true)
         end
      end
   end
   
   for i= 0,Ladders -1 do
      for j= 0,3 do
         ImgLevel:blit(LadderXpos[i]*12,(LadderYpos[i]-j)*12, ImgTiles,0*12,4*12,24,12, true)
      end
   end
   
   PinitX = PlayerXpos
   PinitY = PlayerYpos
   
end

function SetObjProps()
   -- reading object properties
   for i=0,Enemies-1 do
      if ObjProps[i] ~= nil then
         EnemyDir[i] = ObjProps[i]
      else
         EnemyDir[i] = 0
      end
   end
   
   for i=0,PlatformsUsed-1 do
      if ObjProps[Enemies+i] ~= nil then
         PlatformElevation[i] = ObjProps[Enemies+i]
         if PlatformElevation[i] > 3 then
            PlatformDir[i] = 1
            PlatformElevation[i] = 4-(PlatformElevation[i] -4)
         else
            PlatformDir[i] = 0
         end
         PlatformElevation[i] = PlatformElevation[i] *12
      else
         PlatformElevation[i] = 0
         PlatformDir[i] = 0
      end
   end
end

function SettingsLoad()
   if FileExist("DATA/","Settings.dat") then
      FileSettings = io.input("DATA/Settings.dat")
         
         if FileSettings:read() == "1" then
            BatteryAlert = true
         else
            BatteryAlert = false
         end
         
         MusicVol = tonumber(FileSettings:read())
         if MusicVol == nil then MusicVol = 5 end
         
         SFXVol = tonumber(FileSettings:read())
         if SFXVol == nil then SFXVol = 5 end
         
      FileSettings:close()
   else
      FirstRun = true
   end
end

function SettingsSave()
   FileSettings = io.output("DATA/Settings.dat")
      if BatteryAlert then
         FileSettings:write("1" .. string.char(10))
      else
         FileSettings:write("0" .. string.char(10))
      end
      
      FileSettings:write( MusicVol .. string.char(10))
      FileSettings:write( SFXVol .. string.char(10))
      
   FileSettings:close()
end

function JumpButton()
   if Pjump == false and Pladder == false then
      Pjump = true
      SndJump:play()
      if pad:down() or (pad:analogY() > 64) then
         if PlayerYpos < 19 *12 then
            PlayerVelocityY = 0
            PlayerAnimFrame = 2
            PlayerYpos= PlayerYpos +1
         else
            Pjump = false
         end
      else
         PlayerAnimFrame = 0
      end
   end
end

function ThrowButton()
   if PEgg and (Pladder == false) then
      Pbombing = 1
      PEggXpos = PlayerXpos
      PEggYpos = PlayerYpos -12
      PEggVelocityY = -2
      PEgg = false
      if Pdir == 0 then
         PEggVelocityX = 10
      else
         PEggVelocityX = -10
      end
   end
end


-- ------------ --
-- Prepare Game --
-- ------------ --

screen:clear()

BtnActionCross = JumpButton
BtnActionCircle = ThrowButton

-- Setting randomizer
math.randomseed(os.time())
math.random(); math.random(); math.random()

-- Loading graphics
ImgDoor = Image.load("images/bobs_door.png")
BGFile = "images/bg_w1.jpg"
ImgBg = Image.load(BGFile)
TilesFile = "images/tiles_w1.png"

ImgBobChipke = Image.load("images/bobs_chipke.png")
ImgBobChipkeEgg = Image.load("images/bobs_chipke_bomb.png")
ImgBobDizzy = Image.load("images/bobs_dizzy.png")
ImgBobStar = Image.load("images/bobs_star.png")
ImgBobEgg = Image.load("images/bobs_eggs.png")
ImgBobEggsplash = Image.load("images/bobs_eggsplash.png")
ImgBobGoodies = Image.load("images/bobs_goodies.png")

ImgGameOver = Image.load("images/img_gameover.png")
ImgBattery = Image.load("images/battery.png")
ImgGameOver2 = Image.load("images/img_gameover2.jpg")
ImgGameEnd = Image.load("images/img_gameend.jpg")

dofile("DebugWindow.lua")
dofile("enemy_data.lua")
dofile("Sounds.lua")
dofile("BitmapFont.lua")
dofile("CheatMenu.lua")
dofile("PauseMenu.lua")
dofile("Title.lua")
dofile("HiScore.lua")

dofile("Splash.lua")
dofile("CREDITS.lua")

BatteryAlert = true
MusicVol = 5
SFXVol = 5
ButtonLayout = 0

MovDump = 0
NextDump = 0

if FileExist("DATA/","HiScore.dat") then
   HiScoreLoad("data/HiScore.dat")
end
SettingsLoad()

LoadFont (1, "images/Font1.png", 17, 17, 20, -4)
LoadFont (2, "images/Font2.png", 7, 7, 60, -1)
LoadFont (4, "images/Font4.png", 17, 16, 20, -3)

ImgLevel = Image.createEmpty(480,272)

Music.volume(0)
SoundSystem.SFXVolume(math.floor(128/5*SFXVol))
Music.playFile("Music/FRIENDS.MOD",true)

System.setHigh()

for i=1,20 do
   Music.volume(math.floor((128/5*MusicVol)/10*i))
   screen.waitVblankStart(3)
end

while true do
   
   Title()
   
   pad = Controls.read()
   if pad:l() and pad:r() then
      SndLife:play()
      ChtMnuActive = true
   else
      ChtMnuActive = false
   end
   
   for i=20,1,-1 do
      Music.volume(math.floor((128/5*MusicVol)/10*i))      
      screen.waitVblankStart(3)
   end
   Music.stop()
   
   collectgarbage()
   
   -- Initiating Variables
   Level = 0
   Score = 0
   OldScore = 0
   ShowScore = 0
   
   Cheated = false
   toxic = false
   popeye = false
   
   Lives = 3
   
   -- Prepare Level
   NextLevel()
   
   -- Mainloop
   GameRunning = true
   
   SlowMotion = false
   
   PcrossDown = false
   PcircleDown = false
   PsquareDown = false
   PtriangleDown = false
   lButtonDown = false
   rButtonDown = false
   sButtonDown = false
   
   Message = "GET READY!"
   MessageSub = ""
   
   -- DrawScreen
   DrawScreen()
   screen.waitVblankStart()
   
   System.sleep(1000)   
   
   Message = "STAGE " .. math.floor((Level-1)/3)+1 .. " - " .. Level - (math.floor((Level-1)/3)*3)
   MessageSub = ""
   MessageCountdown = 30
   
   Music.playFile("Music/nzs2.xm",true)
   Music.volume(math.floor(128/5*MusicVol))
   SoundSystem.SFXVolume(math.floor(128/5*SFXVol))
   
   while GameRunning do
      
      -- Pmove:
      -- 1 = right
      -- 2 = down
      -- 3 = left
      -- 4 = up
      
      PmoveOld = Pmove
      Pmove = 0
      
      pad = Controls.read()

      if pad:start() then
         if sButtonDown == false then
            PauseMenu()         
            sButtonDown = true   
         end
      elseif sButtonDown then
         sButtonDown = false      
      end
      
      if pad:r() then
         if rButtonDown == false then
            if ChtMnuActive == true then
               DebugMenu()
            end
            rButtonDown = true   
         end
      elseif rButtonDown then
         rButtonDown = false      
      end
      
      if pad:l() then
         if lButtonDown == false then
            lButtonDown = true   
         end      
      elseif lButtonDown then
         lButtonDown = false      
      end
      
      if PHit ~= true then
         
         if pad:up() or (pad:analogY() < -96) then
            if (DoorX == math.floor(PlayerXpos/12)) and (DoorY == math.floor(PlayerYpos/12)) then
               if DoorOpen == true then
                  if CheckLevelExist(Level+1) then
                     NextLevel()
                  else
                     break
                  end
               end
            end
            
            for i = 0,Ladders -1 do
               if PlayerYpos <= LadderYpos[i] *12  and PlayerYpos > (LadderYpos[i] -4) *12 then
                  if PlayerXpos >= (LadderXpos[i] + .5) *12  and PlayerXpos < (LadderXpos[i] +1.5) *12 then
                     PlayerXpos = (LadderXpos[i]+1) *12
                     Pmove = 2
                  end
               end
            end
            
            if Pmove == 2 then
               if Pladder == false then
                  PlayerAnimFrame = 0
                  Pladder = true
                  Pjump = false
                  PlayerVelocityY = 0
               else
                  PlayerAnimFrame = PlayerAnimFrame +1
               end
            elseif Pjump == false then
               Pladder = false
               PlayerYpos = math.floor((PlayerYpos+11)/12) *12
            end
         end
         
         if pad:down() or (pad:analogY() > 96) then
            for i = 0,Ladders -1 do
               if PlayerYpos < LadderYpos[i] *12  and PlayerYpos >= (LadderYpos[i] -4) *12 then
                  if PlayerXpos >= (LadderXpos[i] + .5) *12  and PlayerXpos < (LadderXpos[i] +1.5) *12 then
                     PlayerXpos = (LadderXpos[i]+1) *12
                     Pmove = 4
                  end
               end
            end
            
            if Pmove == 4 then
               if Pladder == false then
                  PlayerAnimFrame = 0
                  Pladder = true
                  Pjump = false
                  PlayerVelocityY = 0
               else
                  PlayerAnimFrame = PlayerAnimFrame +1
               end
            elseif Pjump == false then
               Pladder = false
               PlayerYpos = math.floor(PlayerYpos/12) *12            PlayerYpos = math.floor((PlayerYpos+11)/12) *12
            end
         end
      
         if (pad:left() or (pad:analogX() < -64)) and (Pmove == 0) then
            if Pladder then
               local TileXpos = math.floor((PlayerXpos)/12)
               local TileYpos = math.floor((PlayerYpos +12)/12)
               if IsPlatform(TileXpos,TileYpos) then
                  Pmove = 3
                  Pdir = 1
                  PlayerYpos = (TileYpos-1) *12
                  Pladder = false
               end
            else
               Pmove = 3
               Pdir = 1
            end
         end
         
         if (pad:right() or (pad:analogX() > 64)) and (Pmove == 0) then
            if Pladder then
               local TileXpos = math.floor((PlayerXpos)/12)
               local TileYpos = math.floor((PlayerYpos +12)/12)
               if IsPlatform(TileXpos,TileYpos) then
                  Pmove = 1
                  Pdir = 0
                  PlayerYpos = (TileYpos-1) *12
                  Pladder = false
               end
            else
               Pmove = 1
               Pdir = 0
            end
         end
         
         if pad:cross() then
            if PcrossDown == false then
               PcrossDown = true
               BtnActionCross()
            end
         elseif PcrossDown then
            PcrossDown = false
         end
         
         if pad:circle() then
            if PcircleDown == false then      
               PcircleDown = true         
               BtnActionCircle()
            end
         elseif PcircleDown then
            PcircleDown = false
         end
         
         if pad:triangle() then
            if PtriangleDown == false then
               PtriangleDown = true
            end
         elseif PtriangleDown then
            PtriangleDown = false
         end
         
         if pad:square() then
            if PsquareDown == false then
               PsquareDown = true         
            end
         elseif PsquareDown then
            PsquareDown = false
         end
      end
      
      if ( Pmove ~= PmoveOld ) and ( Pjump == false ) and ( Pladder == false ) then
         PlayerAnimFrame = 0
      end
      
      if PHit == false then
         if Pmove == 1 then
            local TileXpos = math.floor((PlayerXpos)/12)
            local TileYpos = math.floor((PlayerYpos)/12)
            
            if IsSlip(TileXpos,TileYpos +1) == false then
               PlayerXpos = PlayerXpos +3
               PlayerSlide = 3
            else
               if PlayerSlide < 4 then
                  PlayerSlide = PlayerSlide + .2
               end
               
               PlayerXpos = PlayerXpos +PlayerSlide
            end
            
            if PlayerXpos > 480-8 then 
               PlayerXpos = 480-8
               Pmove = 0
            end
            if PlayerXpos < 8 then
               PlayerXpos = 8
               Pmove = 0
            end
            
            local TileXposNew = math.floor((PlayerXpos) /12)
            
            if TileXpos ~= TileXposNew then
               if Pplatform == -1 then
                  if IsPlatform(TileXposNew,TileYpos +1) == false then
                     Pjump = true
                     PlayerAnimFrame = 2
                  end
               else
                  if TileXposNew > PlatformX[Pplatform]+2 then
                     Pplatform = -1
                     if IsPlatform(TileXposNew,TileYpos +1) == false then
                        Pjump = true
                        PlayerAnimFrame = 2
                     else
                        PlayerYpos = TileYpos*12
                     end
                  end
               end
            end
         elseif Pmove == 2 then
            PlayerYpos = PlayerYpos -3
            Pladder = false
            
            for i = 0,Ladders -1 do
               if PlayerYpos <= LadderYpos[i] *12  and PlayerYpos > (LadderYpos[i] -4) *12 then
                  if PlayerXpos >= (LadderXpos[i] + .5) *12  and PlayerXpos < (LadderXpos[i] +1.5) *12 then
                     PlayerXpos = (LadderXpos[i]+1) *12
                     Pmove = 2
                     Pladder = true
                     PlayerSlide = 0
                  end
               end
            end
            
            if Pladder == false then
               PlayerYpos = math.floor((PlayerYpos+11)/12) *12
            end
            
         elseif Pmove == 3 then
            local TileXpos = math.floor((PlayerXpos)/12)
            local TileYpos = math.floor((PlayerYpos)/12)
            
            if IsSlip(TileXpos,TileYpos +1) == false then
               PlayerXpos = PlayerXpos -3
               PlayerSlide = -3
            else
               if PlayerSlide > -4 then
                  PlayerSlide = PlayerSlide - .2
               end
               
               PlayerXpos = PlayerXpos +PlayerSlide
            end
            
            if PlayerXpos > 480-8 then 
               PlayerXpos = 480-8
               Pmove = 0
            end
            if PlayerXpos < 8 then
               PlayerXpos = 8
               Pmove = 0
            end
            
            local TileXposNew = math.floor((PlayerXpos) /12)
            
            if TileXpos ~= TileXposNew then
               if Pplatform == -1 then
                  if IsPlatform(TileXposNew,TileYpos +1) == false then
                     Pjump = true
                     PlayerAnimFrame = 2
                  end
               else
                  if TileXposNew < PlatformX[Pplatform] then
                     Pplatform = -1
                     if IsPlatform(TileXposNew,TileYpos +1) == false then
                        Pjump = true
                        PlayerAnimFrame = 2
                     else
                        PlayerYpos = TileYpos*12
                     end
                  end
               end
            end
            
         elseif Pmove == 4 then
            PlayerYpos = PlayerYpos +3
            PlayerSlide = 0
            
         else
            
            local TileXpos = math.floor((PlayerXpos)/12)
            local TileYpos = math.floor((PlayerYpos)/12)
            
            if ((IsSlip(TileXpos,TileYpos +1) == false) and IsPlatform(TileXpos,TileYpos +1)) or Pplatform ~= -1 then
               PlayerSlide = 0
            else
               if PlayerSlide ~= 0 then
                  
                  if PlayerSlide >= .2 then
                     PlayerSlide = PlayerSlide - .2
                  elseif PlayerSlide <= -.2 then
                     PlayerSlide = PlayerSlide + .2
                  else
                     PlayerSlide = 0
                  end
                  
                  PlayerXpos = PlayerXpos +PlayerSlide
                  if PlayerXpos > 480-8 then 
                     PlayerXpos = 480-8
                     Pmove = 0
                     PlayerSlide = 0
                  elseif PlayerXpos < 8 then
                     PlayerXpos = 8
                     Pmove = 0
                     PlayerSlide = 0
                  end
                  
                  local TileXposNew = math.floor((PlayerXpos) /12)
                  
                  if TileXpos ~= TileXposNew then
                     if Pplatform == -1 then
                        if IsPlatform(TileXposNew,TileYpos +1) == false then
                           Pjump = true
                           PlayerAnimFrame = 2
                        end
                     else
                        if TileXposNew > PlatformX[Pplatform]+2 then
                           Pplatform = -1
                           if IsPlatform(TileXposNew,TileYpos +1) == false then
                              Pjump = true
                              PlayerAnimFrame = 2
                           else
                              PlayerYpos = TileYpos*12
                           end
                        end
                     end
                  end
               end   
            end
         end
      end
      
      CheckCollision()
      
      DrawScreen()
      screen.waitVblankStart(3)
      
      if DoorOpen then
         ExitLevelCountdown = ExitLevelCountdown -1
         if ExitLevelCountdown < 1 then
            DoWirlAnim()
            if CheckLevelExist(Level+1) then
               NextLevel()
            else
               break
            end
         end
      end
      
      if FreezeEnemies > 0 then FreezeEnemies = FreezeEnemies -1 end
      if SlowMotion then screen.waitVblankStart(30) end
      
      if (OldScore < 12000) and (Score >= 12000) then
         Lives = Lives +1
         SndLife:play()
      elseif (OldScore < 24000) and (Score >= 24000) then
         Lives = Lives +1
         SndLife:play()
      end
      OldScore = Score
      
      if MovDump > 0 then
         screen:save("ms0:/PICTURE/SCR" .. NextDump .. ".JPG")
         MovDump = MovDump -1
         NextDump = NextDump +1
         if MovDump == 0 then SndLife:play() end
      end
   end

   print ("-* Game Over *-")
   
   local GameOverDelay = 50
   
   while GameOverDelay > 0 do
      GameOverDelay = GameOverDelay -1   
      DrawScreen()
      screen.waitVblankStart(3)
   end
   
   if Lives < 0 then   
      screen:clear()
      screen:blit(0, 0, ImgGameOver2,false)
      
      PrintLine = "SCORE: " .. Score
      FontDraw(1,screen ,(480 -FontTextsize(1,PrintLine))/2 ,220,PrintLine)
      PrintLine = "LEVEL: " .. Level
      FontDraw(1,screen ,(480 -FontTextsize(1,PrintLine))/2 ,200,PrintLine)
      
      screen:flip()
      
      screen:clear()
      screen:blit(0, 0, ImgGameOver2,false)
      
      PrintLine = "SCORE: " .. Score
      FontDraw(1,screen ,(480 -FontTextsize(1,PrintLine))/2 ,220,PrintLine)
      PrintLine = "LEVEL: " .. Level
      FontDraw(1,screen ,(480 -FontTextsize(1,PrintLine))/2 ,200,PrintLine)
      
      screen.waitVblankStart(3)
   else
      DoCredits()
      
      screen:clear()
      screen:blit(0, 0, ImgGameEnd,false)
      PrintLine = "SCORE: " .. Score
      FontDraw(1,screen ,(480 -FontTextsize(1,PrintLine))/2 ,220,PrintLine)
      PrintLine = "LEVEL: " .. Level
      FontDraw(1,screen ,(480 -FontTextsize(1,PrintLine))/2 ,200,PrintLine)
      
      screen:flip()
      
      screen:clear()
      screen:blit(0, 0, ImgGameEnd,false)
      PrintLine = "SCORE: " .. Score
      FontDraw(1,screen ,(480 -FontTextsize(1,PrintLine))/2 ,220,PrintLine)
      PrintLine = "LEVEL: " .. Level
      FontDraw(1,screen ,(480 -FontTextsize(1,PrintLine))/2 ,200,PrintLine)
      
      screen.waitVblankStart(3)
   end
   
   for i=20,1,-1 do
      Music.volume(math.floor((128/5*MusicVol)/10*i))
      screen.waitVblankStart(3)
   end   
   
   Music.stop()
   collectgarbage(collect)
   WaitForCross2(4)
   
   if Cheated == false then
      HiScoreChk()
      HiScoreSave("data/HiScore.dat")
   end
   
   Music.volume(0)
   SoundSystem.SFXVolume(math.floor(128/5*SFXVol))
   Music.playFile("Music/FRIENDS.MOD",true)
   
   for i=1,20 do
      Music.volume(math.floor((128/5*MusicVol)/10*i))
      screen.waitVblankStart(3)
   end
   
   HiScoreAnimated(10)   
end

