Fonts = {}

function LoadFont (FntID, FntImg, FntSizeX, FntSizeY, CharsOnRow, Spacing)
	Fonts[FntID] = {}
	Fonts[FntID].Image = Image.load(FntImg)
	Fonts[FntID].SizeX = FntSizeX
	Fonts[FntID].SizeY = FntSizeY
	Fonts[FntID].CharsOnRow = CharsOnRow	
	Fonts[FntID].Spacing = Spacing
end

function FontDraw(FntID,DestImg,DestX,DestY,SrcText)
	if SrcText then
		local CharW = Fonts[FntID].SizeX
		local CharH = Fonts[FntID].SizeY
		
		local CharIndex = 0
		
		local CharPos = 0
		local CharPosX = 0
		local CharPosY = 0
		
		-- for i = 1 , string.len(SrcText) do
		for i = string.len(SrcText),1,-1 do
			Char = string.sub (SrcText,i,i)
			CharPos = string.byte(Char) -32
			
			if (CharPos > -1) and (CharPos < 60) then				
				CharPosY = math.floor(CharPos/Fonts[FntID].CharsOnRow)
				CharPosX = CharPos - (CharPosY*Fonts[FntID].CharsOnRow)
				DestImg:blit(DestX + (i-1)*(CharW +Fonts[FntID].Spacing), DestY, Fonts[FntID].Image, CharPosX * CharW , CharPosY * CharH ,CharW,CharH, true)				
			end
		end
	end
end

function FontTextsize(FntID,SrcText)
	if SrcText then
		local TSize = 0

		TSize = string.len(SrcText) * (Fonts[FntID].SizeX+Fonts[FntID].Spacing)
		return TSize
	else
		return 0
	end
end