function DebugMenu()
   
   local DebugOps = {}
   
   DebugOps[1] = {}
   DebugOps[1].Name = "USB-Mode"
   DebugOps[1].Function = StartUsbMode

   DebugOps[2] = {}
   DebugOps[2].Name = "Debug Window"
   DebugOps[2].Function = SwapDebug
   
   DebugOps[3] = {}
   DebugOps[3].Name = "Slowmotion"
   DebugOps[3].Function = SwapSlowmotion

   DebugOps[4] = {}
   DebugOps[4].Name = "Raster"
   DebugOps[4].Function = DrawRaster

   DebugOps[5] = {}
   DebugOps[5].Name = "Screen Dump"
   DebugOps[5].Function = StartScrDump

   DebugOps[6] = {}
   DebugOps[6].Name = "Movie Dump"
   DebugOps[6].Function = StartMovDump

   DebugOps[7] = {}
   DebugOps[7].Name = "-------------"
   DebugOps[7].Function = VoidFunc

   DebugOps[8] = {}
   DebugOps[8].Name = "Level Skip"
   DebugOps[8].Function = NextLevel

   DebugOps[9] = {}
   DebugOps[9].Name = "Obtain Key"
   DebugOps[9].Function = GetChestKey

   DebugOps[10] = {}
   DebugOps[10].Name = "Unlock Door"
   DebugOps[10].Function = UnlockDoor

   DebugOps[11] = {}
   DebugOps[11].Name = "-------------"
   DebugOps[11].Function = VoidFunc
   
   DebugOps[12] = {}
   DebugOps[12].Name = "Options"
   DebugOps[12].Function = Options   
   
   DebugOps[13] = {}
   DebugOps[13].Name = "-------------"
   DebugOps[13].Function = VoidFunc
  
   DebugOps[14] = {}
   DebugOps[14].Name = "End Game"
   DebugOps[14].Function = EndGame   
  
   
   local DebCur = 1
   
   local NrOps = 14
   
   local InMenu = true
   local RedrawMenu = true
   
   local PadDown = false
   local PadUp = false
   local PadX = false
   local PadO = false
   
         
   while true do
      pad = Controls.read()
      if not(pad:cross()) and not(pad:circle()) then break end
      screen.waitVblankStart()
   end

   while InMenu do
      if RedrawMenu then
         -- screen:flip()
         screen:fillRect(182, 7, 116, NrOps*10 +16, Color.new(128,128,128))
         screen:fillRect(185, 10, 110, NrOps*10 +10, Color.new(0,0,0))
         
         for i = 1,NrOps do
            if i == DebCur then
               screen:print(190,5 + i*10,DebugOps[i].Name, Color.new(255,255,192))
            else
               screen:print(190,5 + i*10,DebugOps[i].Name, Color.new(128,128,128))
            end
         end
         screen:flip()
         RedrawMenu = false
      end
      
      pad = Controls.read()
      
      if pad:up() then
         if PadUp == false then
            PadUp = true
            DebCur = DebCur -1
            if DebCur == 0 then DebCur = NrOps end
            RedrawMenu = true
         end
      else
         PadUp = false
      end
      
      if pad:down() then
         if PadDown == false then
            PadDown = true
            DebCur = DebCur +1
         if DebCur == NrOps +1 then DebCur = 1 end
            RedrawMenu = true
         end
      else
         PadDown = false            
      end
      
      if pad:circle() then
         if PadO == false then
            PadO = true
            InMenu = false
         end
      else
         PadO = false
      end
      
      if pad:cross() then
         if PadO == false then
            PadX = true
            InMenu = false
            
            DebugOps[DebCur].Function()
         end
      else
         PadX = false
      end
      
      screen.waitVblankStart(3)      
   end
   
   while true do
      pad = Controls.read()
      if not(pad:cross()) and not(pad:circle()) then break end
      screen.waitVblankStart()
   end
end

function StartScrDump()
   MovDump = 1
end

function StartMovDump()
   MovDump = 300
end


function StartUsbMode()
   
   screen:flip()
   local PrintLine = "USB-MODE"
   FontDraw(4,screen ,(480 -FontTextsize(4,PrintLine))/2 ,100,PrintLine)
   screen:flip()
      
   System.usbDiskModeActivate()
   WaitForCross2()
   System.usbDiskModeDeactivate()
   
end

function SwapDebug()
   if DWindowVisible then 
      DWindowVisible = false
   else
      DWindowVisible = true
   end
end

function SwapSlowmotion()
   if SlowMotion then 
      SlowMotion = false
   else
      SlowMotion = true
   end
end

function DrawRaster()
   for i = 0,21 do
      ImgLevel:drawLine(0,i*12,479,i*12)
   end
   
   for i = 0,39 do
      ImgLevel:drawLine(i*12,0,i*12,271)
   end   
end

function EndGame()
   Lives = -1
   GameRunning = false
end

function GetChestKey()
   PGotKey = true
end

function VoidFunc()
end
