dofile("enemy_data.lua")

-- Loading graphics
TilesFile = "tiles_w2.png"
BGFile = "BG.JPG"

ImgSpecialTiles = Image.load("images/EditorIcons.png")
ImgTiles = Image.load("images/" .. TilesFile)
ImgTiles:blit(0,180,ImgSpecialTiles,false)

ImgDoor = Image.load("images/bobs_door.png")
-- ImgBg = Image.load("images/bg.jpg")

ImgBobChipke = Image.load("images/bobs_chipke.png")
ImgBobEgg = Image.load("images/bobs_eggs.png")
ImgBobGoodies = Image.load("images/bobs_goodies.png")

ImgLevel = Image.createEmpty(480,272)
ImgGrid = Image.createEmpty(480,272)
ImgHandle = Image.createEmpty(12,12)

-- Preset Variables
CurX = 0
CurY = 0

TCurX = 0
TCurY = 0

Level = 1

function ShowTXT(FleName,WndName)
   local WndCaption = "Up/Down to scroll, Circle to exit"
   if WndName then
      WndCaption = WndName .. " - " .. WndCaption
   end
   
   local FleLn = {}
   local NextLn = ""

   FleLn.Count = 0
   FleLn.Top = 0
   
   for line in io.lines(FleName) do
      FleLn[FleLn.Count] = line
      FleLn.Count = FleLn.Count +1
   end
   
   while true do
   
      DrawScreen()
      screen:fillRect(5*8 -7,2*9 -7,(50)*8 +13,(25+1)*9 +13,Color.new(128,128,128))
      screen:fillRect(5*8 -4,2*9 -4,(50)*8 +7,(25+1)*9 +7,Color.new(0,0,0))
      screen:fillRect(5*8 -4,2*9 -4,(50)*8 +7,12,Color.new(0,0,128))
      
      for i =0,24 do
         if FleLn[i+FleLn.Top] ~= nil then
            screen:print(5*8,2*9-1,WndCaption,Color.new(255,255,255))
            screen:print(5*8,(2+1+i)*9,FleLn[i+FleLn.Top],Color.new(255,255,255))
         end
      end
      
      pad = Controls.read()
      
      if pad:up() then
         if UDown < 2 then
            if FleLn.Top > 0 then FleLn.Top = FleLn.Top -1 end
            if UDown == 0 then UDown = 8 end
         else
            UDown = UDown -1
         end
      elseif UDown ~= 0 then
         UDown = 0
      end

      if pad:down() then
         if DDown < 2 then
            if FleLn.Top < FleLn.Count -25 then FleLn.Top = FleLn.Top +1 end
            if UDown == 0 then UDown = 8 end
         else
            DDown = DDown -1
         end
      elseif DDown ~= 0 then
         DDown = 0
      end

      if pad:circle() then
         break
      end
      
      screen.flip()
      screen.waitVblankStart(3)
   end
   
   while Controls.read():circle() do
      screen.waitVblankStart(3)      
   end
end

function ReadTile(UnitX,UnitY)
   if (UnitX >= 0) and (UnitX <40) and (UnitY >= 0) and (UnitY <22) then
      return string.byte(GameField[UnitY+1], UnitX+1)
   else
      return -1
   end
end

function IsPlatform(UnitX,UnitY)
   if (UnitX >= 0) and (UnitX <40) and (UnitY >= 0) and (UnitY <22) then   
      if BlockPlatform[string.byte(GameField[UnitY+1], UnitX+1)] then
         return true
      else
         return false
      end
   else
      return -1
   end
end

function IsCollide(UnitX,UnitY)
   if (UnitX >= 0) and (UnitX <40) and (UnitY >= 0) and (UnitY <22) then
      if BlockCollide[string.byte(GameField[UnitY+1], UnitX+1)] then
         return true
      else
         return false
      end
   else
      return -1
   end
end

function IsHit(UnitX,UnitY)
   if (UnitX >= 0) and (UnitX <40) and (UnitY >= 0) and (UnitY <22) then
      if BlockHit[string.byte(GameField[UnitY+1], UnitX+1)] then
         return true
      else
         return false
      end
   else
      return -1
   end
end

function IsSlip(UnitX,UnitY)
   if (UnitX >= 0) and (UnitX <40) and (UnitY >= 0) and (UnitY <22) then
      if BlockSlip[string.byte(GameField[UnitY+1], UnitX+1)] then
         return true
      else
         return false
      end
   else
      return -1
   end
end

function WriteTile(UnitX,UnitY,NewUnit)
   GameField[UnitY+1] = string.sub(GameField[UnitY+1],1,UnitX) .. string.char(NewUnit) .. string.sub(GameField[UnitY+1],UnitX+2,string.len(GameField[UnitY+1]))
end

function LoadLevel(DatFile)
   GameField = {}
   
   local BlockProp = 0
   
   BlockPlatform = {}
   BlockCollide = {}
   BlockHit = {}
   BlockSlip = {}

   ObjProps = {}
   ObjProps.count = 0
   
   LevFile = io.open(DatFile, "rb")
   
   for i = 1,22 do
      GameField[i] = LevFile:read(40)
   end
   for i = 0,255 do
      FileByte = LevFile:read(1)
      if FileByte then
         BlockProp = string.byte( FileByte )
         
         BlockPlatform[i] = IsBitSet(BlockProp,1)
         BlockCollide[i] = IsBitSet(BlockProp,2)
         BlockHit[i] = IsBitSet(BlockProp,3)
         BlockSlip[i] = IsBitSet(BlockProp,4)
      elseif BlockPlatform[i] == nil then
         BlockPlatform[i] = false
         BlockCollide[i] = false
         BlockHit[i] = false
         BlockSlip[i] = false
      end
   end
   
   local NextByte      
   NextByte = LevFile:read(1)
   
   if (NextByte ~= nil) then
     local NewTiles = ""
     while string.byte( NextByte ) ~= 0 do
        NewTiles = NewTiles .. NextByte
        NextByte = LevFile:read(1)
     end
     
     if NewTiles ~= "" then
        TilesFile = NewTiles
        ImgTiles = Image.load("images/" .. TilesFile)
        ImgTiles:blit(0,180,ImgSpecialTiles,false)
     end
   end

   NextByte = LevFile:read(1)
   if (NextByte ~= nil) then
      local NewBG = ""
      while string.byte( NextByte ) ~= 0 do
         NewBG = NewBG .. NextByte
         NextByte = LevFile:read(1)
      end
      
      if NewBG ~= "" then
         BGFile = NewBG
      end
   end

   NextByte = LevFile:read(1)
   if (NextByte ~= nil) then
     while (string.byte( NextByte ) ~= 255) do
        ObjProps[ObjProps.count] = string.byte( NextByte )
        ObjProps.count = ObjProps.count +1
        NextByte = LevFile:read(1)
        if NextByte == nil then break end
     end
   end
   
   LevFile:close()
end

function SaveLevel(DatFile)
   -- GameField = {}
   
   if PlayerXpos == -1 then
      System.message("You need to set the players starting possition.",0)
      return
   end

   if DoorX == -1 then
      System.message("You need to set an exit.",0)
      return
   end

   if Enemies == 0 then
      System.message("You need at least 1 enemy.",0)
      return
   end
   
   if EggSpownersUsed == 0 then
      System.message("You need at least 1 egg spowning place.",0)
      return
   end
   
   local BlockProp = 0
   
   LevFile = io.open(DatFile, "wb")
   
   for i = 1,22 do
      -- GameField[i] = LevFile:read(40)
      LevFile:write(GameField[i])
   end
   
   for i = 0,255 do
      BlockProp = 0
      if BlockPlatform[i] then BlockProp = BlockProp +1 end
      if BlockCollide[i]  then BlockProp = BlockProp +2 end
      if BlockHit[i]      then BlockProp = BlockProp +4 end
      if BlockSlip[i]     then BlockProp = BlockProp +8 end
      LevFile:write(string.char(BlockProp))
   end
   
   LevFile:write(TilesFile .. string.char(0))
   LevFile:write(BGFile .. string.char(0))

   -- Save Object Properties
   StoreObjProps()
   for i=0,ObjProps.count-1 do
      LevFile:write(string.char(ObjProps[i]))
   end
   LevFile:write(255)
   
   LevFile:close()
end

function CreateLevel(DatFile)
   LoadLevel("data/clear.lvl")
end

function CheckLevelExist(LevNr)
   Myfiles = System.listDirectory("data/")
   for i=1, table.getn(Myfiles) do      
      if string.lower(Myfiles[i].name) == "level" .. LevNr .. ".lvl" then
         return true
      end      
   end
   return false
end

function IsBitSet(SValue,Bit)
   if math.floor(((SValue / (2^Bit)) - math.floor(SValue / (2^Bit))) * 2) == 1 then   
      return true
   else
      return false
   end
end

function PrepairLevel()
   
   local TileNr
   local TileXpos
   local TileYpos
   
   Ladders = 0
   LadderXpos = nil
   LadderYpos = nil
   
   LadderXpos = {}
   LadderYpos = {}   
   
   DoorX = -1
   DoorY = 0
   
   KeyX = -1
   KeyY = 0
      
   PlayerXpos = -1
   PlayerYpos = 0
   
   MaxEggSpowners = 10
   EggSpownersUsed = 0   
   EggSpownerX = {}
   EggSpownerY = {}
   
   PlatformX = {}
   PlatformY = {}
   PlatformElevation = {}
   PlatformDir = {}
   PlatformsUsed = 0
   
   Enemies = 0
   EnemyXpos = nil
   EnemyYpos = nil
   EnemyType = nil
   EnemyDir = nil
   
   EnemyXpos = {}
   EnemyYpos = {}
   EnemyType = {}
   EnemyDir = {}
   
   
   for j= 0,21 do
      for i= 0,39 do
         TileNr = ReadTile(i,j)
         
         if TileNr == 64 then -- ladder
            LadderXpos[Ladders] = i
            LadderYpos[Ladders] = j
            Ladders = Ladders +1
            TileNr = 255
         elseif TileNr == 237 then -- Platform
            PlatformX[PlatformsUsed] = i
            PlatformY[PlatformsUsed] = j
            
            PlatformElevation[PlatformsUsed] = 0
            PlatformDir[PlatformsUsed] = 0
            
            PlatformsUsed = PlatformsUsed +1
            TileNr = 255
            -- print ("platform at: X" .. i .. " Y" .. j)
            
         elseif TileNr == 241 then -- Door (EXIT)
            DoorX = i
            DoorY = j
            
            TileNr = 255
         elseif TileNr == 242 then -- Key
            KeyX = i
            KeyY = j
            
            TileNr = 255
         elseif TileNr == 240 then -- Egg Spowner
            if EggSpownersUsed < MaxEggSpowners then
               EggSpownerX[EggSpownersUsed] = i
               EggSpownerY[EggSpownersUsed] = j
               EggSpownersUsed = EggSpownersUsed +1               
            end
            TileNr = 255
            
         elseif TileNr == 253 then -- Enemy Turtle
            EnemyXpos[Enemies] = i -- *12 +6
            EnemyYpos[Enemies] = j -- *12
            EnemyType[Enemies] = 1
            
            Enemies = Enemies +1
            TileNr = 255
            
         elseif TileNr == 252 then -- Enemy Monkey
            EnemyXpos[Enemies] = i -- *12 +6
            EnemyYpos[Enemies] = j -- *12
            EnemyType[Enemies] = 2
            
            Enemies = Enemies +1
            TileNr = 255
            
         elseif TileNr == 251 then -- Enemy Croc
            EnemyXpos[Enemies] = i -- *12 +6
            EnemyYpos[Enemies] = j -- *12
            EnemyType[Enemies] = 3
            
            Enemies = Enemies +1
            TileNr = 255
            
         elseif TileNr == 250 then -- Enemy Snale
            EnemyXpos[Enemies] = i -- *12 +6
            EnemyYpos[Enemies] = j -- *12
            EnemyType[Enemies] = 4
            
            Enemies = Enemies +1
            TileNr = 255
            
         elseif TileNr == 249 then -- Enemy Pinky
            EnemyXpos[Enemies] = i -- *12 +6
            EnemyYpos[Enemies] = j -- *12
            EnemyType[Enemies] = 5
            
            Enemies = Enemies +1
            TileNr = 255
            
         elseif TileNr == 248 then -- Enemy Mad Turtle
            EnemyXpos[Enemies] = i -- *12 +6
            EnemyYpos[Enemies] = j -- *12
            EnemyType[Enemies] = 6
            
            Enemies = Enemies +1
            TileNr = 255
         
         elseif TileNr == 247 then -- Enemy Sparky
            EnemyXpos[Enemies] = i -- *12 +6
            EnemyYpos[Enemies] = j -- *12
            EnemyType[Enemies] = 7
            
            Enemies = Enemies +1
            TileNr = 255
            
         elseif TileNr == 254 then -- PlayerPos
            PlayerXpos = i -- * 12 + 6
            PlayerYpos = j -- * 12
            TileNr = 255
            
         end

         TileYpos = math.floor(TileNr/16)
         TileXpos = TileNr - (TileYpos*16)
                  
         ImgLevel:blit(i*12,j*12, ImgTiles,TileXpos*12,TileYpos*12,12,12, false)

      end
   end
      
   -- PinitX = PlayerXpos
   -- PinitY = PlayerYpos
end

function SetObjProps()
   -- reading object properties
   for i=0,Enemies-1 do
      if ObjProps[i] ~= nil then
         EnemyDir[i] = ObjProps[i]
      else
         EnemyDir[i] = 0
      end
   end
   
   for i=0,PlatformsUsed-1 do
      if ObjProps[Enemies+i] ~= nil then
         PlatformElevation[i] = ObjProps[Enemies+i]
         if PlatformElevation[i] > 3 then
            PlatformDir[i] = 1
            PlatformElevation[i] = 4-(PlatformElevation[i] -4)
         else
            PlatformDir[i] = 0
         end
      else
         PlatformElevation[i] = 0
         PlatformDir[i] = 0
      end
   end
end

function StoreObjProps()
   ObjProps = nil
   ObjProps = {}

   local NxtPlatf = 0
   local NxtEnemy = 0

   for iy=0,21 do
      for ix=0,47 do
         for i=0,Enemies-1 do
            if (ix==EnemyXpos[i]) and (iy==EnemyYpos[i]) then
               ObjProps[NxtEnemy] = EnemyDir[i]
               NxtEnemy = NxtEnemy +1
            end
         end
         for i=0,PlatformsUsed-1 do
            if (ix==PlatformX[i]) and (iy==PlatformY[i]) then
               if PlatformDir[i] == 1 then
                  ObjProps[Enemies+NxtPlatf] = 8-PlatformElevation[i]
               else
                  ObjProps[Enemies+NxtPlatf] = PlatformElevation[i]
               end
               NxtPlatf = NxtPlatf +1            
            end
         end
      end
   end
   ObjProps.count=Enemies+NxtPlatf
end

-- Drawing functions
function DrawLadders()
   for i= 0,Ladders -1 do
      for j= 0,3 do
         screen:blit(LadderXpos[i]*12,(LadderYpos[i]-j)*12, ImgTiles,0*12,4*12,24,12, true)
      end
      if ShowHandles then
         screen:blit(LadderXpos[i]*12,LadderYpos[i]*12, ImgHandle,0,0,12,12, true)
      end
      -- print ("Lader " .. i .. " - X:" .. LadderXpos[i] .. " Y:" .. LadderYpos[i])
   end
end

function DrawPlatforms()
   if PlatformsUsed > 0 then
      for i =0, PlatformsUsed -1 do
         --[[
         if PlatformDir[i] == 1 then
            PlatformElevation[i] = PlatformElevation[i] -1.5
            if PlatformElevation[i] <= 0 then
               PlatformDir[i] = 0
               PlatformElevation[i] = 0
            end
         else
            PlatformElevation[i] = PlatformElevation[i] +1.5
            if PlatformElevation[i] >= 12 *4 then
               PlatformDir[i] = 1
               PlatformElevation[i] = 12 *4
            end         
         end
         screen:blit( PlatformX[i] *12, PlatformY[i] *12 -PlatformElevation[i], ImgTiles , 13 *12 , 14 *12 , 36, 12, true )
         ]]--
         
         screen:drawLine(PlatformX[i] *12 +18, PlatformY[i] *12 +6,PlatformX[i] *12 +18, PlatformY[i] *12 -48,Color.new(255,255,0))
         screen:blit( PlatformX[i] *12, PlatformY[i] *12 - (PlatformElevation[i]*12), ImgTiles , 13 *12 , 14 *12 , 36, 12, true )
         if ShowHandles then
            screen:blit( PlatformX[i] *12, PlatformY[i] *12 , ImgHandle,0,0,12,12, true)
         end
      end
   end
end

function DrawKey()   
   if KeyX ~= -1 then
      screen:blit(KeyX *12 -12, KeyY *12 -12, ImgBobGoodies,6 *24,0,24,24, true)
      if ShowHandles then
         screen:blit( KeyX *12, KeyY *12 , ImgHandle,0,0,12,12, true)
      end
   end
end

function DrawEggSpowing()
   if EggSpownersUsed > 0 then
      for i =0, EggSpownersUsed -1 do
         local BobSize = 24
         screen:blit(EggSpownerX[i]*12 -(BobSize/2), EggSpownerY[i]*12 +12 -BobSize +1, ImgBobEgg, 0, 0, BobSize, BobSize, true)
         if ShowHandles then
            screen:blit( EggSpownerX[i] *12, EggSpownerY[i] *12 , ImgHandle,0,0,12,12, true)
         end
      end
   end
end

function DrawDoor()
   if DoorX ~= -1 then
      screen:blit(DoorX *12 -12, DoorY *12 -24, ImgDoor,0 ,0 ,36 ,36 , true)
      if ShowHandles then
         screen:blit(DoorX *12, DoorY *12 , ImgHandle,0,0,12,12, true)
      end
   end
end

function DrawPlayer()
   if PlayerXpos ~= -1 then
      local BobsImg = ImgBobChipke
      local BobsSize = 24
      screen:blit((PlayerXpos * 12 + 6) -(BobsSize/2), (PlayerYpos * 12) +12 -BobsSize, BobsImg,0 ,0 ,BobsSize ,BobsSize , true)
      if ShowHandles then
         screen:blit(PlayerXpos *12, PlayerYpos *12 , ImgHandle,0,0,12,12, true)
      end
   end
end

function DrawEnemies()
   if Enemies > 0 then
      for i=0,Enemies -1 do
      
         local EImage = enemy[EnemyType[i]].ImgBob
         local BobSize = enemy[EnemyType[i]].size
         
         local BobPosX = EnemyXpos[i] *12 + 6
         local BobPosY = EnemyYpos[i] *12

         screen:blit(BobPosX -(BobSize/2), BobPosY +12 -BobSize +1, EImage, 0, EnemyDir[i]*BobSize, BobSize, BobSize, true)
         if ShowHandles then
            screen:blit(EnemyXpos[i] *12, EnemyYpos[i] *12 , ImgHandle,0,0,12,12, true)
         end
      end
   end
end

function DrawRaster()
  ImgGrid:clear(Color.new(0,0,0,0))
  for i = 0,21 do
    -- ImgGrid:drawLine(0,i*12,479,i*12,Color.new(96,96,96))
    if i/4 == math.floor(i/4) then
       ImgGrid:drawLine(0,i*12,479,i*12,Color.new(96,32,32))
    else
       ImgGrid:drawLine(0,i*12,479,i*12,Color.new(192,192,192))
    end
  end
  for i = 0,39 do
    ImgGrid:drawLine(i*12,0,i*12,271-8,Color.new(128,128,128))
  end   
end

function DrawCursor()
   screen:drawLine(CurX*12,CurY*12,CurX*12+11,CurY*12,Color.new(255,0,0))
   screen:drawLine(CurX*12,CurY*12,CurX*12,CurY*12+11,Color.new(255,0,0))
   screen:drawLine(CurX*12+11,CurY*12+11,CurX*12+11,CurY*12,Color.new(255,0,0))
   screen:drawLine(CurX*12+11,CurY*12+11,CurX*12,CurY*12+11,Color.new(255,0,0))
end

function DrawScreen()
   -- screen:blit(0, 0, ImgBg, false)

   screen:blit(0,0, ImgLevel,0,0,480,272, false)
   if ShowGrid then screen:blit(0,0, ImgGrid,0,0,480,272, true) end
   DrawDoor()
   DrawLadders()
   DrawEggSpowing()
   DrawKey()
   DrawPlatforms()
   DrawEnemies()
   DrawPlayer()

   screen:print(10,22*12,"LEVEL " .. Level,Color.new(255,255,255))
end

function DrawTilewindow()
   screen:fillRect(7, 7, 198, 198, Color.new(128,128,128))
   screen:blit(10,10, ImgTiles,0,0,192,192, false)
end

function DrawTileCursor()
   screen:drawLine(TCurX*12+10,TCurY*12+10,TCurX*12+11+10,TCurY*12+10,Color.new(255,0,0))
   screen:drawLine(TCurX*12+10,TCurY*12+10,TCurX*12+10,TCurY*12+11+10,Color.new(255,0,0))
   screen:drawLine(TCurX*12+11+10,TCurY*12+11+10,TCurX*12+11+10,TCurY*12+10,Color.new(255,0,0))
   screen:drawLine(TCurX*12+11+10,TCurY*12+11+10,TCurX*12+10,TCurY*12+11+10,Color.new(255,0,0))
end

function DrawHandle()
   ImgHandle:clear(Color.new(0,0,0,0))
   ImgHandle:fillRect(2, 2, 8, 8, Color.new(255,255,0))
   ImgHandle:fillRect(4, 4, 4, 4, Color.new(0,0,0))
end

function ClearTyle(UnitX,UnitY)
   local OldTile = ReadTile(UnitX,UnitY)
   if (OldTile >= 247) and (OldTile < 254) then
      for i=0,Enemies -1 do
         if (UnitX==EnemyXpos[i]) and (UnitY==EnemyYpos[i]) then
            EnemyXpos[i]=EnemyXpos[Enemies -1]
            EnemyYpos[i]=EnemyYpos[Enemies -1]
            EnemyType[i]=EnemyType[Enemies -1]
            EnemyDir[i]=EnemyDir[Enemies -1]
            Enemies = Enemies -1
            EnemyXpos[Enemies]=nil
            EnemyYpos[Enemies]=nil
            EnemyType[Enemies]=nil
            EnemyDir[Enemies]=nil
         end
      end
   elseif OldTile == 64 then
      for i=0,Ladders -1 do
         if (UnitX==LadderXpos[i]) and (UnitY==LadderYpos[i]) then
            LadderXpos[i]=LadderXpos[Ladders -1]
            LadderYpos[i]=LadderYpos[Ladders -1]
            Ladders = Ladders -1
            LadderXpos[Ladders]=nil
            LadderYpos[Ladders]=nil
         end
      end
   elseif OldTile == 237 then
      for i=0,PlatformsUsed -1 do
         if (UnitX==PlatformX[i]) and (UnitY==PlatformY[i]) then
            PlatformX[i]=PlatformX[PlatformsUsed -1]
            PlatformY[i]=PlatformY[PlatformsUsed -1]
            PlatformsUsed = PlatformsUsed -1
            PlatformX[PlatformsUsed]=nil
            PlatformY[PlatformsUsed]=nil
         end
      end
   elseif OldTile == 240 then
      for i=0,EggSpownersUsed -1 do
         if (UnitX==EggSpownerX[i]) and (UnitY==EggSpownerY[i]) then
            EggSpownerX[i]=EggSpownerX[EggSpownersUsed -1]
            EggSpownerY[i]=EggSpownerY[EggSpownersUsed -1]
            EggSpownersUsed = EggSpownersUsed -1
            EggSpownerX[EggSpownersUsed]=nil
            EggSpownerY[EggSpownersUsed]=nil
         end
      end
   elseif OldTile == 241 then
      DoorX = -1
   elseif OldTile == 242 then
      KeyX = -1
   elseif OldTile == 254 then
      PlayerXpos = -1
   end
end

function DrawTile(i,j,TileNr)
         
         if TileNr == 64 then -- ladder
            LadderXpos[Ladders] = i
            LadderYpos[Ladders] = j
            Ladders = Ladders +1
            TileNr = 255
         elseif TileNr == 237 then -- Platform
            PlatformX[PlatformsUsed] = i
            PlatformY[PlatformsUsed] = j
            
            PlatformElevation[PlatformsUsed] = 0
            PlatformDir[PlatformsUsed] = 0
            
            PlatformsUsed = PlatformsUsed +1
            TileNr = 255
            -- print ("platform at: X" .. i .. " Y" .. j)
            
         elseif TileNr == 241 then -- Door (EXIT)
            if DoorX ~= -1 then
               WriteTile(DoorX,DoorY,255)
            end
            
            DoorX = i
            DoorY = j
            
            TileNr = 255
         elseif TileNr == 242 then -- Key
            if KeyX ~= -1 then
               WriteTile(KeyX,KeyY,255)
            end
            
            KeyX = i
            KeyY = j
            
            TileNr = 255
         elseif TileNr == 240 then -- Egg Spowner
            if EggSpownersUsed < MaxEggSpowners then
               EggSpownerX[EggSpownersUsed] = i
               EggSpownerY[EggSpownersUsed] = j
               EggSpownersUsed = EggSpownersUsed +1               
            end
            TileNr = 255
            
         elseif TileNr == 253 then -- Enemy Turtle
            EnemyXpos[Enemies] = i -- *12 +6
            EnemyYpos[Enemies] = j -- *12
            EnemyType[Enemies] = 1
            EnemyDir[Enemies] = 0
            
            Enemies = Enemies +1
            TileNr = 255
            
         elseif TileNr == 252 then -- Enemy Monkey
            EnemyXpos[Enemies] = i -- *12 +6
            EnemyYpos[Enemies] = j -- *12
            EnemyType[Enemies] = 2
            EnemyDir[Enemies] = 0
            
            Enemies = Enemies +1
            TileNr = 255
            
         elseif TileNr == 251 then -- Enemy Croc
            EnemyXpos[Enemies] = i -- *12 +6
            EnemyYpos[Enemies] = j -- *12
            EnemyType[Enemies] = 3
            EnemyDir[Enemies] = 0
            
            Enemies = Enemies +1
            TileNr = 255
            
         elseif TileNr == 250 then -- Enemy Snale
            EnemyXpos[Enemies] = i -- *12 +6
            EnemyYpos[Enemies] = j -- *12
            EnemyType[Enemies] = 4
            EnemyDir[Enemies] = 0
            
            Enemies = Enemies +1
            TileNr = 255
            
         elseif TileNr == 249 then -- Enemy Pinky
            EnemyXpos[Enemies] = i -- *12 +6
            EnemyYpos[Enemies] = j -- *12
            EnemyType[Enemies] = 5
            EnemyDir[Enemies] = 0
            
            Enemies = Enemies +1
            TileNr = 255
            
         elseif TileNr == 248 then -- Enemy Mad Turtle
            EnemyXpos[Enemies] = i -- *12 +6
            EnemyYpos[Enemies] = j -- *12
            EnemyType[Enemies] = 6
            EnemyDir[Enemies] = 0
            
            Enemies = Enemies +1
            TileNr = 255
         
         elseif TileNr == 247 then -- Enemy Sparky
            EnemyXpos[Enemies] = i -- *12 +6
            EnemyYpos[Enemies] = j -- *12
            EnemyType[Enemies] = 7
            EnemyDir[Enemies] = 0
            
            Enemies = Enemies +1
            TileNr = 255

         elseif TileNr == 254 then -- PlayerPos
            if PlayerXpos ~= -1 then
               WriteTile(PlayerXpos,PlayerYpos,255)
            end
            
            PlayerXpos = i -- * 12 + 6
            PlayerYpos = j -- * 12
            TileNr = 255
            
         end

         TileYpos = math.floor(TileNr/16)
         TileXpos = TileNr - (TileYpos*16)
                  
         ImgLevel:blit(i*12,j*12, ImgTiles,TileXpos*12,TileYpos*12,12,12, false)

end

function ReadTile(UnitX,UnitY)
   if (UnitX >= 0) and (UnitX <40) and (UnitY >= 0) and (UnitY <22) then
      return string.byte(GameField[UnitY+1], UnitX+1)
   else
      return -1
   end
end

--[[
function not(NotValue)
   if NotValue then
      return false
   else
      return true
   end
end
]]-- 


-- Menu Object Properties
function MnuObjProps(ObjX,ObjY)
   local ObjType = ReadTile(ObjX,ObjY)
   local MinVal = 0
   local MaxVal = 1
   
   local DestVal = 0
   local DestIdx = -1
   local UpdateVal = false
   
   MaxVal = 1
   
   local ObjectName = ""
   
   if ObjType == 237 then -- Platform
      MinVal = 0
      MaxVal = 7
      ObjectName = "Platform"
      
      for i=0,PlatformsUsed-1 do
         if (ObjX == PlatformX[i]) and (ObjY == PlatformY[i]) then
            DestIdx = i
            if PlatformDir[i] == 1 then
               DestVal = 8-PlatformElevation[i]
            else
               DestVal = PlatformElevation[i]
            end
         end
      end
      
   elseif (ObjType >= 247) and (ObjType <= 254) then
      MinVal = 0
      MaxVal = 1      
      ObjectName = "Enemy"
   
      for i=0,Enemies-1 do
         if (ObjX == EnemyXpos[i]) and (ObjY == EnemyYpos[i]) then
            DestIdx = i
            DestVal = EnemyDir[i]
         end
      end
      
   else
      ObjectName = ""
      System.message("No Properties can be set at this possition.",0)
   end
   
   if DestIdx ~= -1 then
   while true do
      DrawScreen()
      
      pad = Controls.read()
      
      if pad:up() then
         if UDown < 2 then
            DestVal = MaxVal
            
            -- PrepairLevel()
            UpdateVal = true
            
            if UDown == 0 then UDown = 8 end
         else
            UDown = UDown -1
         end
      elseif UDown ~= 0 then
        UDown = 0
      end

      if pad:down() then
         if DDown < 2 then
            DestVal = MinVal
            
            -- PrepairLevel()
            UpdateVal = true
            
            if DDown == 0 then DDown = 8 end
         else
            DDown = DDown -1
         end
      elseif DDown ~= 0 then
        DDown = 0
      end

      if pad:left() then
         if LDown < 2 then
            DestVal = DestVal-1
            if DestVal<MinVal then DestVal = MaxVal end
            
            -- PrepairLevel()
            UpdateVal = true
            
            if LDown == 0 then LDown = 8 end
         else
            LDown = LDown -1
         end
      elseif LDown ~= 0 then
        LDown = 0
      end

      if pad:right() then
         if RDown < 2 then
            DestVal = DestVal+1
            if DestVal>MaxVal then DestVal = MinVal end

            -- PrepairLevel()
            UpdateVal = true
            
            if RDown == 0 then RDown = 8 end
         else
            RDown = RDown -1
         end
      elseif RDown ~= 0 then
        RDown = 0
      end

      if pad:circle() then
         if CircleDown == 0 then
            CircleDown = 1
            break
         end
      elseif CircleDown ~= 0 then
        CircleDown = 0
      end

      if UpdateVal then
         if ObjectName == "Platform" then
           if DestVal >3 then
              PlatformElevation[DestIdx] = 4-(DestVal-4)
              PlatformDir[DestIdx] = 1
           else
              PlatformElevation[DestIdx] = DestVal
              PlatformDir[DestIdx] = 0
           end
         elseif ObjectName == "Enemy" then
           EnemyDir[DestIdx] = DestVal
         end
         UpdateVal = false
      end

      screen:print(120,22*12,ObjectName .. " " .. DestIdx .. " Props: < " .. DestVal .. " >",Color.new(255,255,255))
      
      screen:flip()
      screen.waitVblankStart(3)
   end
   end
end

-- LevelShift
function MnuLevelShift()
   while true do
      DrawScreen()
      
      pad = Controls.read()
      
      if pad:up() then
         if UDown < 2 then
            local tmpField = GameField[1]
            for i=1,21 do
              GameField[i]=GameField[i+1]              
            end
            GameField[22] = tmpField
            
            for i=0,PlatformsUsed-1 do
               PlatformY[i] = PlatformY[i] -1
               if PlatformY[i] == -1 then PlatformY[i] = 21 end
            end
            for i=0,Enemies-1 do
               EnemyYpos[i] = EnemyYpos[i] -1
               if EnemyYpos[i] == -1 then EnemyYpos[i] = 21 end
            end
            
            StoreObjProps()
            PrepairLevel()
            SetObjProps()
            
            if UDown == 0 then UDown = 8 end
         else
            UDown = UDown -1
         end
      elseif UDown ~= 0 then
        UDown = 0
      end

      if pad:down() then
         if DDown < 2 then
            local tmpField = GameField[22]
            for i=22,2,-1 do
              GameField[i]=GameField[i-1]              
            end
            GameField[1] = tmpField

            for i=0,PlatformsUsed-1 do
               PlatformY[i] = PlatformY[i] +1
               if PlatformY[i] == 22 then PlatformY[i] = 0 end
            end
            for i=0,Enemies-1 do
               EnemyYpos[i] = EnemyYpos[i] +1
               if EnemyYpos[i] == 22 then EnemyYpos[i] = 0 end
            end
            
            StoreObjProps()
            PrepairLevel()
            SetObjProps()
            
            if DDown == 0 then DDown = 8 end
         else
            DDown = DDown -1
         end
      elseif DDown ~= 0 then
        DDown = 0
      end

      if pad:left() then
         if LDown < 2 then
            for i=1,22 do
              GameField[i]=string.sub(GameField[i],1-string.len(GameField[i])) .. string.sub(GameField[i],1,1)
            end

            for i=0,PlatformsUsed-1 do
               PlatformX[i] = PlatformX[i] -1
               if PlatformX[i] == -1 then PlatformX[i] = 47 end
            end
            for i=0,Enemies-1 do
               EnemyXpos[i] = EnemyXpos[i] -1
               if EnemyXpos[i] == -1 then EnemyXpos[i] = 47 end
            end
            
            StoreObjProps()
            PrepairLevel()
            SetObjProps()
            
            if LDown == 0 then LDown = 8 end
         else
            LDown = LDown -1
         end
      elseif LDown ~= 0 then
        LDown = 0
      end

      if pad:right() then
         if RDown < 2 then
            for i=1,22 do
              GameField[i] = string.sub(GameField[i],-1) .. string.sub(GameField[i],1,string.len(GameField[i])-1)
            end

            for i=0,PlatformsUsed-1 do
               PlatformX[i] = PlatformX[i] +1
               if PlatformX[i] == 48 then PlatformX[i] = 0 end
            end
            for i=0,Enemies-1 do
               EnemyXpos[i] = EnemyXpos[i] +1
               if EnemyXpos[i] == 48 then EnemyXpos[i] = 0 end
            end
            
            StoreObjProps()
            PrepairLevel()
            SetObjProps()
            
            if RDown == 0 then RDown = 8 end
         else
            RDown = RDown -1
         end
      elseif RDown ~= 0 then
        RDown = 0
      end

      if pad:circle() then
         if CircleDown == 0 then
            CircleDown = 1
            break
         end
      elseif CircleDown ~= 0 then
        CircleDown = 0
      end

      screen:print(120,22*12,"LEVEL SHIFT - Press O to exit",Color.new(255,255,255))
      
      screen:flip()
      screen.waitVblankStart(3)
   end   
end

-- BlockSelect
function MnuBlockProp(BlockNr)
   local Mnu = {}
   Mnu.Sel = 0
   Mnu.Caption = {}
   
   if BlockPlatform[BlockNr] then
      Mnu.Caption[0] = "Platform +"
   else
      Mnu.Caption[0] = "Platform -"
   end
   if BlockCollide[BlockNr] then
      Mnu.Caption[1] = "-W-a-l-l-+"
   else
      Mnu.Caption[1] = "-W-a-l-l--"
   end
   if BlockHit[BlockNr] then
      Mnu.Caption[2] = "Hit      +"
   else
      Mnu.Caption[2] = "Hit      -"
   end
   if BlockSlip[BlockNr] then
      Mnu.Caption[3] = "Slippery +"
   else
      Mnu.Caption[3] = "Slippery -"
   end
   
   Mnu.Width = 0
   for i=0,table.getn(Mnu.Caption) do
      if string.len(Mnu.Caption[i]) > Mnu.Width then
         Mnu.Width = string.len(Mnu.Caption[i])
      end
   end
   
   while true do
      DrawScreen()

      DrawTilewindow()
      DrawTileCursor()
      
      pad = Controls.read()
      
      screen:fillRect(7+200, 7, 6 + Mnu.Width *8, 7 + (table.getn(Mnu.Caption)+1) *8, Color.new(128,128,128))
      screen:fillRect(9+200, 9, 2 + Mnu.Width *8, 3 + (table.getn(Mnu.Caption)+1) *8, Color.new(0,0,0))
      
      for i=0,table.getn(Mnu.Caption) do
         if i==Mnu.Sel then
            screen:print(11+200, 11+i*8, Mnu.Caption[i],Color.new(255,255,255))
         else
            screen:print(11+200, 11+i*8, Mnu.Caption[i],Color.new(128,128,128))            
         end
      end
      
      
      if pad:up() then
         if UDown < 2 then
            Mnu.Sel = Mnu.Sel -1
            if Mnu.Sel < 0 then Mnu.Sel = table.getn(Mnu.Caption) end
            if UDown == 0 then UDown = 8 end
         else
            UDown = UDown -1
         end
      elseif UDown ~= 0 then
        UDown = 0
      end
      
      if pad:down() then
         if DDown < 2 then
            Mnu.Sel = Mnu.Sel +1
            if Mnu.Sel > table.getn(Mnu.Caption) then Mnu.Sel = 0 end
            if DDown == 0 then DDown = 8 end
         else
            DDown = DDown -1
         end
      elseif DDown ~= 0 then
        DDown = 0
      end

      if pad:cross() then
         if CrossDown == 0 then
            CrossDown = 1
   
            if Mnu.Sel == 0 then   
               BlockPlatform[BlockNr] = not(BlockPlatform[BlockNr])
            elseif Mnu.Sel == 1 then   
               BlockCollide[BlockNr] = not(BlockCollide[BlockNr])
            elseif Mnu.Sel == 2 then   
               BlockHit[BlockNr] = not(BlockHit[BlockNr])
            elseif Mnu.Sel == 3 then   
               BlockSlip[BlockNr] = not(BlockSlip[BlockNr])
            end

   if BlockPlatform[BlockNr] then
      Mnu.Caption[0] = "Platform +"
   else
      Mnu.Caption[0] = "Platform -"
   end
   if BlockCollide[BlockNr] then
      Mnu.Caption[1] = "-W-a-l-l-+"
   else
      Mnu.Caption[1] = "-W-a-l-l--"
   end
   if BlockHit[BlockNr] then
      Mnu.Caption[2] = "Hit      +"
   else
      Mnu.Caption[2] = "Hit      -"
   end
   if BlockSlip[BlockNr] then
      Mnu.Caption[3] = "Slippery +"
   else
      Mnu.Caption[3] = "Slippery -"
   end
   
         end
      elseif CrossDown ~= 0 then
        CrossDown = 0
      end
      
      if pad:circle() then
         if CircleDown == 0 then
            CircleDown = 1
            break
         end
      elseif CircleDown ~= 0 then
        CircleDown = 0
      end
      
      screen:flip()
      screen.waitVblankStart(3)
   end   
end


function BlockSelect()
   while true do
     DrawScreen()

      screen:fillRect(7+200, 7, 6 + 10 *8, 7 + (4) *8, Color.new(128,128,128))
      screen:fillRect(9+200, 9, 2 + 10 *8, 3 + (4) *8, Color.new(0,0,0))

   local BlockNr = TCurX+TCurY*16

   if BlockPlatform[BlockNr] then
      screen:print(11+200, 11+0*8, "Platform +",Color.new(128,128,128))            
   else
      screen:print(11+200, 11+0*8, "Platform -",Color.new(128,128,128))            
   end
   if BlockCollide[BlockNr] then
      screen:print(11+200, 11+1*8, "         +",Color.new(128,128,128))            
   else
      screen:print(11+200, 11+1*8, "         -",Color.new(128,128,128))            
   end
   if BlockHit[BlockNr] then
      screen:print(11+200, 11+2*8, "Hit      +",Color.new(128,128,128))            
   else
      screen:print(11+200, 11+2*8, "Hit      -",Color.new(128,128,128))            
   end
   if BlockSlip[BlockNr] then
      screen:print(11+200, 11+3*8, "Slippery +",Color.new(128,128,128))            
   else
      screen:print(11+200, 11+3*8, "Slippery -",Color.new(128,128,128))            
   end      

   
      pad = Controls.read()
      
      if pad:right() then
         if RDown < 2 then
            TCurX = TCurX +1
            if TCurX >= 16 then TCurX = TCurX -16 end
            if RDown == 0 then RDown = 8 end
         else
            RDown = RDown -1
         end
      elseif RDown ~= 0 then
        RDown = 0
      end
   
      if pad:left() then
         if LDown < 2 then
            TCurX = TCurX -1
            if TCurX < 0 then TCurX = TCurX +16 end
            if LDown == 0 then LDown = 8 end
         else
            LDown = LDown -1
         end
      elseif LDown ~= 0 then
        LDown = 0
      end
      
      if pad:up() then
         if UDown < 2 then
            TCurY = TCurY -1
            if TCurY < 0 then TCurY = TCurY +16 end
            if UDown == 0 then UDown = 8 end
         else
            UDown = UDown -1
         end
      elseif UDown ~= 0 then
        UDown = 0
      end
      
      if pad:down() then
         if DDown < 2 then
            TCurY = TCurY +1
            if TCurY >= 16 then TCurY = TCurY -16 end
            if DDown == 0 then DDown = 8 end
         else
            DDown = DDown -1
         end
      elseif DDown ~= 0 then
        DDown = 0
      end


      if pad:cross() then
         if CrossDown == 0 then
            CrossDown = 1
            break
         end
      elseif CrossDown ~= 0 then
         CrossDown = 0
      end

      if pad:circle() then
         if CircleDown == 0 then
            CircleDown = 1
            break
         end
      elseif CircleDown ~= 0 then
         CircleDown = 0
      end

      if pad:square() then
         if SquareDown == 0 then
            SquareDown = 1
            MnuBlockProp(TCurX+TCurY*16)
         end
      elseif SquareDown ~= 0 then
         SquareDown = 0
      end
        
      DrawTilewindow()
      DrawTileCursor()
      
      screen:flip()
      screen.waitVblankStart(3)
   end
end

function MnuBG()
   local Mnu = {}
   Mnu.Sel = 0
   Mnu.Caption = {}
   
   Myfiles = System.listDirectory("images/")
   
   Mnu.Nextfile = 0
   for i=1, table.getn(Myfiles) do
      if string.sub(string.lower(Myfiles[i].name),1,2) == "bg" then
         Mnu.Caption[Mnu.Nextfile] = Myfiles[i].name
         Mnu.Nextfile = Mnu.Nextfile +1
      end      
   end
   
   Mnu.Width = 0
   for i=0,table.getn(Mnu.Caption) do
      if string.len(Mnu.Caption[i]) > Mnu.Width then
         Mnu.Width = string.len(Mnu.Caption[i])
      end
      if string.lower(BGFile) == string.lower(Mnu.Caption[i]) then
         Mnu.Sel = i
      end
   end

   local ImgBGPrev = Image.load("images/" .. Mnu.Caption[Mnu.Sel])
   for i=0,47 do
      for j=0,27 do
         ImgBGPrev:pixel(i,j,ImgBGPrev:pixel(i*10,j*10))   
      end
   end
   
   while true do
      DrawScreen()
      
      pad = Controls.read()
      
      screen:fillRect(7, 7, 6 + Mnu.Width *8, 7 + (table.getn(Mnu.Caption)+1) *8, Color.new(128,128,128))
      screen:fillRect(9, 9, 2 + Mnu.Width *8, 3 + (table.getn(Mnu.Caption)+1) *8, Color.new(0,0,0))

      screen:fillRect(17 + Mnu.Width *8, 7, 48+6, 27+6, Color.new(128,128,128))
      screen:blit(20 + Mnu.Width *8,10, ImgBGPrev,0,0,48,27, false)
      
      for i=0,table.getn(Mnu.Caption) do
         if i==Mnu.Sel then
            screen:print(11, 11+i*8, Mnu.Caption[i],Color.new(255,255,255))
         else
            screen:print(11, 11+i*8, Mnu.Caption[i],Color.new(128,128,128))            
         end
      end
      
      if pad:up() then
         if UDown < 2 then
            Mnu.Sel = Mnu.Sel -1
            if Mnu.Sel < 0 then Mnu.Sel = table.getn(Mnu.Caption) end
            ImgBGPrev = Image.load("images/" .. Mnu.Caption[Mnu.Sel])
            for i=0,47 do
               for j=0,27 do
                  ImgBGPrev:pixel(i,j,ImgBGPrev:pixel(i*10,j*10))   
               end
            end
            if UDown == 0 then UDown = 8 end
         else
            UDown = UDown -1
         end
      elseif UDown ~= 0 then
        UDown = 0
      end
      
      if pad:down() then
         if DDown < 2 then
            Mnu.Sel = Mnu.Sel +1
            if Mnu.Sel > table.getn(Mnu.Caption) then Mnu.Sel = 0 end
            ImgBGPrev = Image.load("images/" .. Mnu.Caption[Mnu.Sel])
            for i=0,47 do
               for j=0,27 do
                  ImgBGPrev:pixel(i,j,ImgBGPrev:pixel(i*10,j*10))   
               end
            end
            if DDown == 0 then DDown = 8 end
         else
            DDown = DDown -1
         end
      elseif DDown ~= 0 then
        DDown = 0
      end

      if pad:cross() then
         if CrossDown == 0 then
            CrossDown = 1
            BGFile = Mnu.Caption[Mnu.Sel]
            -- ImgTiles = Image.load("images/" .. TilesFile)
            -- PrepairLevel()
            break
         end
      elseif CrossDown ~= 0 then
        CrossDown = 0
      end
      
      if pad:circle() then
         if CircleDown == 0 then
            CircleDown = 1
            break
         end
      elseif CircleDown ~= 0 then
        CircleDown = 0
      end
      
      screen:flip()
      screen.waitVblankStart(3)
   end
end

function MnuTiles()
   local Mnu = {}
   Mnu.Sel = 0
   Mnu.Caption = {}
 
   Myfiles = System.listDirectory("images/")

   Mnu.Nextfile = 0
   for i=1, table.getn(Myfiles) do
      if string.sub(string.lower(Myfiles[i].name),1,7) == "tiles_w" then
         Mnu.Caption[Mnu.Nextfile] = Myfiles[i].name
         Mnu.Nextfile = Mnu.Nextfile +1
      end      
   end
   
   Mnu.Width = 0
   for i=0,table.getn(Mnu.Caption) do
      if string.len(Mnu.Caption[i]) > Mnu.Width then
         Mnu.Width = string.len(Mnu.Caption[i])
      end
      if string.lower(TilesFile) == string.lower(Mnu.Caption[i]) then
         Mnu.Sel = i
      end
   end

   local ImgTilesPrev = Image.load("images/" .. Mnu.Caption[Mnu.Sel])
      
   while true do
      DrawScreen()
      
      pad = Controls.read()
      
      screen:fillRect(7, 7, 6 + Mnu.Width *8, 7 + (table.getn(Mnu.Caption)+1) *8, Color.new(128,128,128))
      screen:fillRect(9, 9, 2 + Mnu.Width *8, 3 + (table.getn(Mnu.Caption)+1) *8, Color.new(0,0,0))

      screen:fillRect(17 + Mnu.Width *8, 7, 198, 198, Color.new(128,128,128))
      screen:blit(20 + Mnu.Width *8,10, ImgTilesPrev,0,0,192,192, false)
      
      for i=0,table.getn(Mnu.Caption) do
         if i==Mnu.Sel then
            screen:print(11, 11+i*8, Mnu.Caption[i],Color.new(255,255,255))
         else
            screen:print(11, 11+i*8, Mnu.Caption[i],Color.new(128,128,128))            
         end
      end
      
      if pad:up() then
         if UDown < 2 then
            Mnu.Sel = Mnu.Sel -1
            if Mnu.Sel < 0 then Mnu.Sel = table.getn(Mnu.Caption) end
            ImgTilesPrev = Image.load("images/" .. Mnu.Caption[Mnu.Sel])
            if UDown == 0 then UDown = 8 end
         else
            UDown = UDown -1
         end
      elseif UDown ~= 0 then
        UDown = 0
      end
      
      if pad:down() then
         if DDown < 2 then
            Mnu.Sel = Mnu.Sel +1
            if Mnu.Sel > table.getn(Mnu.Caption) then Mnu.Sel = 0 end
            ImgTilesPrev = Image.load("images/" .. Mnu.Caption[Mnu.Sel])
            if DDown == 0 then DDown = 8 end
         else
            DDown = DDown -1
         end
      elseif DDown ~= 0 then
        DDown = 0
      end

      if pad:cross() then
         if CrossDown == 0 then
            CrossDown = 1
            TilesFile = Mnu.Caption[Mnu.Sel]
            ImgTiles = Image.load("images/" .. TilesFile)
            ImgTiles:blit(0,180,ImgSpecialTiles,false)
            
            StoreObjProps()
            PrepairLevel()
            SetObjProps()

            break
         end
      elseif CrossDown ~= 0 then
        CrossDown = 0
      end
      
      if pad:circle() then
         if CircleDown == 0 then
            CircleDown = 1
            break
         end
      elseif CircleDown ~= 0 then
        CircleDown = 0
      end
      
      screen:flip()
      screen.waitVblankStart(3)
   end
end

function MnuLevSelect()
   local Mnu = {}
   Mnu.Sel = 0
   Mnu.Caption = {}
   Mnu.Nextfile = 0
   
   local LastLevel = 0
   while CheckLevelExist(LastLevel +1) do
      LastLevel = LastLevel +1
      Mnu.Caption[Mnu.Nextfile] = "level" .. LastLevel .. ".lvl"
      Mnu.Nextfile = Mnu.Nextfile +1      
   end
   Mnu.Sel = Level - 1
      
   Mnu.Width = 0
   for i=0,table.getn(Mnu.Caption) do
      if string.len(Mnu.Caption[i]) > Mnu.Width then
         Mnu.Width = string.len(Mnu.Caption[i])
      end
      if string.lower(BGFile) == string.lower(Mnu.Caption[i]) then
         Mnu.Sel = i
      end
   end

   local ImgBGPrev = Image.createEmpty(40,22)
   local TLevFile = io.open("data/" .. Mnu.Caption[Mnu.Sel], "rb")
   
   local Buffer1 = TLevFile:read(22*40)
   local Buffer2 = TLevFile:read(256)

   local ClrBlack = Color.new(0,0,0)
   local ClrWhite = Color.new(255,255,255)
   local ClrDeepRed = Color.new(192,64,64)
   
   ImgBGPrev:clear(ClrWhite)
   for i = 1,40 do
      for j = 1,22 do
         local BlockTile = string.sub(Buffer1,(j-1)*40+i,(j-1)*40+i)
         BlockTile = string.byte(BlockTile)
         local BlockProp = string.sub(Buffer2,BlockTile+1,BlockTile+1)
         BlockProp = string.byte(BlockProp)
         if IsBitSet(BlockProp,1) then
            ImgBGPrev:pixel(i-1,j-1,ClrBlack)
         elseif BlockTile == 64 then
            for k = 1,4 do
               ImgBGPrev:pixel(i-1,j-k,ClrDeepRed)
               ImgBGPrev:pixel(i,j-k,ClrDeepRed)
            end
         elseif BlockTile == 237 then
            for k = 0,2 do
               ImgBGPrev:pixel(i-1+k,j-1,ClrDeepRed)
            end
         else
            -- ImgBGPrev:pixel(i-1,j-1,ClrWhite)
         end
      end
   end

   
   while true do
      DrawScreen()
      
      pad = Controls.read()
      
      screen:fillRect(7, 7, 6 + Mnu.Width *8, 7 + (table.getn(Mnu.Caption)+1) *8, Color.new(128,128,128))
      screen:fillRect(9, 9, 2 + Mnu.Width *8, 3 + (table.getn(Mnu.Caption)+1) *8, Color.new(0,0,0))

      screen:fillRect(17 + Mnu.Width *8, 7, 40+6, 22+6, Color.new(128,128,128))
      screen:blit(20 + Mnu.Width *8,10, ImgBGPrev,0,0,40,22, false)
      
      for i=0,table.getn(Mnu.Caption) do
         if i==Mnu.Sel then
            screen:print(11, 11+i*8, Mnu.Caption[i],Color.new(255,255,255))
         else
            screen:print(11, 11+i*8, Mnu.Caption[i],Color.new(128,128,128))            
         end
      end
      
      if pad:up() then
         if UDown < 2 then
            Mnu.Sel = Mnu.Sel -1
            if Mnu.Sel < 0 then Mnu.Sel = table.getn(Mnu.Caption) end

            TLevFile = io.open("data/" .. Mnu.Caption[Mnu.Sel], "rb")
   
            Buffer1 = TLevFile:read(22*40)
            Buffer2 = TLevFile:read(256)
            TLevFile:close()
            
            ImgBGPrev:clear(ClrWhite)
            for i = 1,40 do
               for j = 1,22 do         
                  local BlockTile = string.sub(Buffer1,(j-1)*40+i,(j-1)*40+i)
                  BlockTile = string.byte(BlockTile)
                  local BlockProp = string.sub(Buffer2,BlockTile+1,BlockTile+1)
                  BlockProp = string.byte(BlockProp)
                  if IsBitSet(BlockProp,1) then
                     ImgBGPrev:pixel(i-1,j-1,ClrBlack)
                  elseif BlockTile == 64 then
                     for k = 1,4 do
                        ImgBGPrev:pixel(i-1,j-k,ClrDeepRed)
                        ImgBGPrev:pixel(i,j-k,ClrDeepRed)
                     end
                  elseif BlockTile == 237 then
                     for k = 0,2 do
                        ImgBGPrev:pixel(i-1+k,j-1,ClrDeepRed)
                     end
                  else
                     -- ImgBGPrev:pixel(i-1,j-1,ClrWhite)
                  end
               end
            end

            if UDown == 0 then UDown = 8 end
         else
            UDown = UDown -1
         end
      elseif UDown ~= 0 then
        UDown = 0
      end
      
      if pad:down() then
         if DDown < 2 then
            Mnu.Sel = Mnu.Sel +1
            if Mnu.Sel > table.getn(Mnu.Caption) then Mnu.Sel = 0 end

            TLevFile = io.open("data/" .. Mnu.Caption[Mnu.Sel], "rb")
   
            Buffer1 = TLevFile:read(22*40)
            Buffer2 = TLevFile:read(256)
            TLevFile:close()
            
            ImgBGPrev:clear(ClrWhite)
            for i = 1,40 do
               for j = 1,22 do         
                  local BlockTile = string.sub(Buffer1,(j-1)*40+i,(j-1)*40+i)
                  BlockTile = string.byte(BlockTile)
                  local BlockProp = string.sub(Buffer2,BlockTile+1,BlockTile+1)
                  BlockProp = string.byte(BlockProp)
                  if IsBitSet(BlockProp,1) then
                     ImgBGPrev:pixel(i-1,j-1,ClrBlack)
                  elseif BlockTile == 64 then
                     for k = 1,4 do
                        ImgBGPrev:pixel(i-1,j-k,ClrDeepRed)
                        ImgBGPrev:pixel(i,j-k,ClrDeepRed)
                     end
                  elseif BlockTile == 237 then
                     for k = 0,2 do
                        ImgBGPrev:pixel(i-1+k,j-1,ClrDeepRed)
                     end
                  else
                     -- ImgBGPrev:pixel(i-1,j-1,ClrWhite)
                  end
               end
            end

            if DDown == 0 then DDown = 8 end
         else
            DDown = DDown -1
         end
      elseif DDown ~= 0 then
        DDown = 0
      end

      if pad:cross() then
         if CrossDown == 0 then
            CrossDown = 1
            -- return Mnu.Caption[Mnu.Sel]
            return Mnu.Sel +1
         end
      elseif CrossDown ~= 0 then
        CrossDown = 0
      end
      
      if pad:circle() then
         if CircleDown == 0 then
            CircleDown = 1
            return -1
         end
      elseif CircleDown ~= 0 then
        CircleDown = 0
      end
      
      screen:flip()
      screen.waitVblankStart(3)
   end
end

function MnuOps()
   local Mnu = {}
   Mnu.Sel = 0
   Mnu.Caption = {}
   Mnu.Caption[0] = "Select Tileset"
   Mnu.Caption[1] = "Select Background"
   Mnu.Caption[2] = "-----------------"
   Mnu.Caption[3] = "Go To Level"
   Mnu.Caption[4] = "Swap Level"
   Mnu.Caption[5] = "-----------------"   
   Mnu.Caption[6] = "Object Properties"   
   Mnu.Caption[7] = "Shift Level"   
   Mnu.Caption[8] = "-----------------"   
   Mnu.Caption[9] = "Help"   
   Mnu.Caption[10] = "-----------------"   
   Mnu.Caption[11] = "Quit"   
   
   Mnu.Width = 0
   for i=0,table.getn(Mnu.Caption) do
      if string.len(Mnu.Caption[i]) > Mnu.Width then
         Mnu.Width = string.len(Mnu.Caption[i])
      end
   end
   
   while true do
      DrawScreen()
      
      pad = Controls.read()
      
      screen:fillRect(7, 7, 6 + Mnu.Width *8, 7 + (table.getn(Mnu.Caption)+1) *8, Color.new(128,128,128))
      screen:fillRect(9, 9, 2 + Mnu.Width *8, 3 + (table.getn(Mnu.Caption)+1) *8, Color.new(0,0,0))
      
      for i=0,table.getn(Mnu.Caption) do
         if i==Mnu.Sel then
            screen:print(11, 11+i*8, Mnu.Caption[i],Color.new(255,255,255))
         else
            screen:print(11, 11+i*8, Mnu.Caption[i],Color.new(128,128,128))            
         end
      end
      
      
      if pad:up() then
         if UDown < 2 then
            Mnu.Sel = Mnu.Sel -1
            if Mnu.Sel < 0 then Mnu.Sel = table.getn(Mnu.Caption) end
            if UDown == 0 then UDown = 8 end
         else
            UDown = UDown -1
         end
      elseif UDown ~= 0 then
        UDown = 0
      end
      
      if pad:down() then
         if DDown < 2 then
            Mnu.Sel = Mnu.Sel +1
            if Mnu.Sel > table.getn(Mnu.Caption) then Mnu.Sel = 0 end
            if DDown == 0 then DDown = 8 end
         else
            DDown = DDown -1
         end
      elseif DDown ~= 0 then
        DDown = 0
      end

      if pad:cross() then
         if CrossDown == 0 then
            CrossDown = 1
            break
         end
      elseif CrossDown ~= 0 then
        CrossDown = 0
      end
      
      if pad:circle() then
         if CircleDown == 0 then
            CircleDown = 1
            break
         end
      elseif CircleDown ~= 0 then
        CircleDown = 0
      end
      
      screen:flip()
      screen.waitVblankStart(3)
   end
   
   if CrossDown == 1 then
      if Mnu.Sel == 0 then
         MnuTiles()
      elseif Mnu.Sel == 1 then
         MnuBG()
      elseif Mnu.Sel == 3 then
         local Resp = MnuLevSelect()
         if Resp ~= -1 then
            Level = Resp
            LoadLevel("data/level" .. Level .. ".lvl") 
            PrepairLevel()
            SetObjProps()
         end
      elseif Mnu.Sel == 4 then
         local Resp = MnuLevSelect()
         if (Resp ~= -1) and (Resp ~= Level) then
            System.message("Do you wish to swap level " .. Level .. " and " .. Resp .. "?",1)
            
            if System.buttonPressed(0) == 1 then
               System.rename("data/level" .. Level .. ".lvl","data/level.lvl")
               System.rename("data/level" .. Resp .. ".lvl","data/level" .. Level .. ".lvl")
               System.rename("data/level.lvl","data/level" .. Resp .. ".lvl")
               
               Level = Resp
               LoadLevel("data/level" .. Level .. ".lvl") 
               PrepairLevel()
               SetObjProps()
            end
         end
      elseif Mnu.Sel == 6 then
         MnuObjProps(CurX,CurY)

      elseif Mnu.Sel == 7 then
         MnuLevelShift()

      elseif Mnu.Sel == 9 then
         ShowTXT("LevelEdit.HLP","HELP")
         
      elseif Mnu.Sel == 11 then
         System.message("Do you wish to exit the editor?",1)
         
         if System.buttonPressed(0) == 1 then
            ExitEditor = true
         end
      end            
   end
end

-- Main Loop
DrawRaster()
DrawHandle()

LoadLevel("data/level" .. Level .. ".lvl")
PrepairLevel()
SetObjProps()

RDown = 0
LDown = 0
UDown = 0
DDown = 0

CrossDown = 0
CircleDown = 0
TriangleDown = 0
SquareDown = 0

StartDown = 0
SelectDown = 0
NoteDown = 0
SLDown = 0
SRDown = 0

ShowGrid = false
ShowHandles = false

ExitEditor = false

while ExitEditor == false do
   DrawScreen()
   -- screen:print(10,22*12,"LEVEL " .. Level,Color.new(255,255,255))
   
   pad = Controls.read()
   
   if pad:right() then
      if RDown < 2 then
         CurX = CurX +1
         if CurX >= 40 then CurX = CurX -40 end
         if RDown == 0 then RDown = 8 end
      else
         RDown = RDown -1
      end
   elseif RDown ~= 0 then
     RDown = 0
   end

   if pad:left() then
      if LDown < 2 then
         CurX = CurX -1
         if CurX < 0 then CurX = CurX +40 end
         if LDown == 0 then LDown = 8 end
      else
         LDown = LDown -1
      end
   elseif LDown ~= 0 then
     LDown = 0
   end
   
   if pad:up() then
      if UDown < 2 then
         CurY = CurY -1
         if CurY < 0 then CurY = CurY +22 end
         if UDown == 0 then UDown = 8 end
      else
         UDown = UDown -1
      end
   elseif UDown ~= 0 then
     UDown = 0
   end
   
   if pad:down() then
      if DDown < 2 then
         CurY = CurY +1
         if CurY >= 22 then CurY = CurY -22 end
         if DDown == 0 then DDown = 8 end
      else
         DDown = DDown -1
      end
   elseif DDown ~= 0 then
     DDown = 0
   end

   if pad:triangle() then
      BlockSelect()
   end

   if pad:cross() then
      if CrossDown == 0 then
         ImgLevel:blit(CurX*12,CurY*12, ImgTiles,TCurX*12,TCurY*12,12,12,false)
         ClearTyle(CurX,CurY)
         DrawTile(CurX,CurY,(TCurY*16)+TCurX)
         WriteTile(CurX,CurY,(TCurY*16)+TCurX)
         CrossDown = 1
      end
   elseif CrossDown ~= 0 then
      CrossDown = 0
   end
   
   if pad:circle() then
      if CircleDown == 0 then
         ImgLevel:blit(CurX*12,CurY*12, ImgTiles,15*12,15*12,12,12,false)
         ClearTyle(CurX,CurY)
         WriteTile(CurX,CurY,255)
         CircleDown = 1
      end
   elseif CircleDown ~= 0 then
      CircleDown = 0
   end

   if pad:square() then
      if SquareDown == 0 then
         if ShowGrid then
            ShowGrid = false
            ShowHandles = false
         else   
            ShowGrid = true
            ShowHandles = true
         end
         SquareDown = 1
      end
   elseif SquareDown ~= 0 then
      SquareDown = 0
   end
   
   if pad:note() then
      if NoteDown == 0 then
         if ShowHandles then
            ShowHandles = false
         else   
            ShowHandles = true
         end
         NoteDown = 1
      end
   elseif NoteDown ~= 0 then
      NoteDown = 0
   end
   
   if pad:start() then
      MnuOps()
   end

   if pad:select() then
      if SelectDown < 31 then SelectDown = SelectDown +1 end
      if SelectDown == 30 then SaveLevel("data/level" .. Level .. ".lvl") end
      if SelectDown < 31 then
         screen:fillRect(0, 22*12, 480/30*SelectDown, 272, Color.new(192,0,0))
         screen:print((480-(10*8))/2,22*12,"SAVE LEVEL",Color.new(255,255,255))
      end
   elseif SelectDown ~= 0 then
      SelectDown = 0
   end
   
   --[[
   if pad:l() and pad:r() then
      MnuOps()
   end
   ]]--
   
   if pad:l() then
      if SLDown < 31 then SLDown = SLDown +1 end
      if SLDown == 30 then
         Level = Level -1
         if Level < 1 then Level = 1 end
         LoadLevel("data/level" .. Level .. ".lvl") 
         PrepairLevel()
         SetObjProps()
      end
      if SLDown < 31 then
         screen:fillRect(0, 22*12, 480/30*SLDown, 272, Color.new(192,0,0))
         screen:print((480-(10*8))/2,22*12,"LOAD LEVEL",Color.new(255,255,255))
      end
   elseif SLDown ~= 0 then
      SLDown = 0
   end

   if pad:r() then
      if SRDown < 31 then SRDown = SRDown +1 end
      if SRDown == 30 then
         if CheckLevelExist(Level +1) then
            Level = Level +1
            LoadLevel("data/level" .. Level .. ".lvl") 
            PrepairLevel()
            SetObjProps()
         else
            System.message("Level " .. Level+1 .. " does not exist. Do you wish to create it?",1)
            
            if System.buttonPressed(0) == 1 then
               Level = Level +1
               CreateLevel(Level)
               PrepairLevel()
            end            
         end
      end
      if SRDown < 31 then
         screen:fillRect(0, 22*12, 480/30*SRDown, 272, Color.new(192,0,0))
         screen:print((480-(10*8))/2,22*12,"LOAD LEVEL",Color.new(255,255,255))
      end
   elseif SRDown ~= 0 then
      SRDown = 0
   end

   DrawCursor()
   screen:flip()
   screen.waitVblankStart(3)
end
